/***************************************************************************
                          cedit.cpp  -  description
                             -------------------
    begin                : Fri Dec 10 1999
    copyright            : (C) 1999 by Tiberiu Craciun
    email                : tiberiu@akela.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cedit.h"
#include "tcp_client.h"
#include "ctcpclient.h"
#include "stabctl/stabctl.h"
#include <kiconloader.h>
#include <kapp.h>


CEdit::CEdit(QObject *parent):QObject(parent,""){
}
CEdit::~CEdit(){
}

/**  */
void CEdit::changeClient(TcpClient *cl){
	client=cl;
}

void CEdit::setTabCtl(STabCtl *t){
	tab=t;
}

QString getExtension(QString file){
		if(file.find('.')==-1){
			return "";
		}
		int len=file.length();
		int index=file.findRev(".",len);
		return file.mid(index+1,len-index).lower();
}
	
void setIcon(STabCtl *tab,int id,QString file){
	  KIconLoader *il=KApplication::getKApplication()->getIconLoader();
	  QString ext=getExtension(file);
	  if(ext=="html" || ext=="htm")
		  tab->setPixmap(id,il->loadIcon("html.xpm"));
	  if(ext=="php" || ext=="php3" || ext=="phps" || ext=="inc")
		  tab->setPixmap(id,il->loadIcon("php.xpm"));
}

void CEdit::addFile(QString file, int ck){
	CFileEdit *e;
  QString p;
  int exist=0;
  for ( e=list.first(); e != 0; e=list.next() ){
	     p=e->getPath();
	     if(p==file){
	     	exist=1;
	     	// activez tabul respectiv
	     	tab->setVisiblePage(e->id);
	     	e->slotNewPos();
	     }
	 }
	if(!exist){
		// adaug un nou tab
//    cerr << ck << endl;
    e=new CFileEdit(file, tab, ck);
		e->setClient(client);
		list.append(e);
	  e->id=tab->insertPage(e->getWidget(),file);
	  setIcon(tab,e->id,file);
	  e->loadFile();
   	tab->setVisiblePage(e->id);
   	files->addFile(file,ck);
   	connect(e,SIGNAL(sigNewPos(int,int,int)),this,SLOT(slotNewPos(int,int,int)));
	}

}

void CEdit::removeFile(QString file){
}

int CEdit::exist(QString file){
	CFileEdit *e;
  int id=tab->visiblePageId();
  for ( e=list.first(); e != 0; e=list.next() ){
	     if(file==e->path){
				return 1;
	     }
	 }
  return 0;
}

void CEdit::saveFile(){
	CFileEdit *e;
  int id=tab->visiblePageId();
  for ( e=list.first(); e != 0; e=list.next() ){
	     if(id==e->id){
				e->save();
	     }
	 }
}

QString CEdit::closeFile(){
	CFileEdit *e;
	QString f("");
  int id=tab->visiblePageId();
  for ( e=list.first(); e != 0; e=list.next() ){
	     if(id==e->id){
				// Sa verific daca este salvat
				e->close();
				f=e->path;
				
				tab->removePage(id);
				list.remove();
				if(!e)
					delete e;
				return f;
	     }
	 }
	return f;
}

void CEdit::saveFile(QString file){
	CFileEdit *e;
  int id=tab->visiblePageId();
  for ( e=list.first(); e != 0; e=list.next() ){
	     if(file==e->path){
				e->save();
	     }
	 }
}

QString CEdit::closeFile(QString file){
	CFileEdit *e;
	QString f("");
  int id=tab->visiblePageId();

  for ( e=list.first(); e != 0; e=list.next() ){
	     if(file==e->path){
				// Sa verific daca este salvat
				e->close();
				f=e->path;
				
				tab->removePage(e->id);
				list.remove();
				if(!e)
					delete e;
				return f;
	     }
	 }
	return f;
}

void CEdit::copy(){
	CFileEdit *e;
  int id=tab->visiblePageId();
  for ( e=list.first(); e != 0; e=list.next() ){
	     if(id==e->id){
	     	e->copy();
	     }
	 }
}

void CEdit::cut(){
	CFileEdit *e;
  int id=tab->visiblePageId();
  for ( e=list.first(); e != 0; e=list.next() ){
	     if(id==e->id){
	     	e->cut();
	     }
	 }
}

void CEdit::paste(){
	CFileEdit *e;
  int id=tab->visiblePageId();
  for ( e=list.first(); e != 0; e=list.next() ){
	     if(id==e->id){
	     	e->paste();
	     }
	 }
}


void CEdit::print(QPrinter *printer){
	CFileEdit *e;
  int id=tab->visiblePageId();
  for ( e=list.first(); e != 0; e=list.next() ){
	     if(id==e->id){
	     	e->print(printer);
	     }
	 }
}

void CEdit::slotNewPos(int type, int Line, int Col){
  emit sigNewPos(type,Line,Col);

}



