/***************************************************************************
                          cedit.h  -  description
                             -------------------
    begin                : Fri Dec 10 1999
    copyright            : (C) 1999 by Tiberiu Craciun
    email                : tiberiu@akela.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CEDIT_H
#define CEDIT_H

#include "cfileedit.h"
#include "cfiles.h"
#include <qprinter.h>
#include <qwidget.h>

class TcpClient;
class STabCtl;
/**
  *@author Tiberiu Craciun
  */

class CEdit:public QObject {
  Q_OBJECT
public: 
	CEdit(QObject *parent);
	~CEdit();

protected: // Protected attributes
  /**  */
  TcpClient *client;
  /** */
  STabCtl	*tab;
  CFiles	*files;
  /**  */
public:
  void changeClient(TcpClient *cl);
  void setTabCtl(STabCtl *t);
  void setFilesView(CFiles *f){ files=f; }
  void addFile(QString file,int ck);
	void removeFile(QString file);
	void saveFile();
	QString closeFile();
	void saveFile(QString file);
	QString closeFile(QString file);
	void copy();
	void cut();
	void paste();
	void print(QPrinter *printer);
	int exist(QString file);
	
protected:	
  QList<CFileEdit> list;

signals:
   void sigNewPos(int type, int Line, int Col);
public slots: // Public slots
  /**  */
  void slotNewPos(int type, int Line, int Col);
};

#endif













