/***************************************************************************
                          cfileedit.h  -  description
                             -------------------
    begin                : Fri Dec 10 1999
    copyright            : (C) 1999 by Tiberiu Craciun
    email                : tiberiu@akela.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CFILEEDIT_H
#define CFILEEDIT_H

#include <qstring.h>
#include <qwidget.h>

#include "kwrite/highlight.h"
#include "kwrite/kwdoc.h"
#include "kwrite/kwview.h"
#include <qprinter.h>
#include <kmsgbox.h>

#include <iostream.h>

//class HlManager;
//class KWriteDoc;
//class KWrite;
class TcpClient;

/**
  *@author Tiberiu Craciun
  */

class CFileEdit : public QObject {
	Q_OBJECT
public: 
	CFileEdit(QString Path, QWidget *parent, int ck);
	~CFileEdit();
	
	void setClient(TcpClient *cl){ client=cl; kw->client=cl; }
	QString getPath(){ return path; }
	QWidget* getWidget(){ return kw; }
	void loadFile(){ 	kw->loadTCP(path); }
	void save(int q=0){
		int s=1;
		if(kw->isModified()){
		       if(q){
		       	  QString msg;
		       	  msg="";
		       	  msg+="Do you want to save file ";
		       	  msg+=path;
		       	  msg+=" ?";
			  if(KMsgBox::yesNo(0, "Save file", msg, KMsgBox::EXCLAMATION) == 2)
			  {s=0;} else {s=1;}
		       }
			if(s){  kw->writeFileToTCP(); }
	 }
	}	
	void copy(){ kw->copy(); }	
	void cut(){ kw->cut(); }	
	void paste(){ kw->paste(); }	
	void print(QPrinter *printer);
	void close();

protected:
  HlManager *hl;
  KWriteDoc *kwd;
  KWrite *kw;
  int check;
  TcpClient *client;
public:
  QString path;
	int id;
signals:
   void sigNewPos(int type, int Line, int Col);
public slots: // Public slots
  /**  */
  void slotNewPos();
};

#endif
















