/***************************************************************************
                    cfiles.cpp -
                             -------------------                                         
                            
    begin                : 9 Sept 1998                                        
    copyright            : (C) 1998 by Stefan Bartel                         
    email                : bartel@rz.uni-potsdam.de                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "qdir.h"
#include "qstrlist.h"
#include <kmsgbox.h>
#include <qfile.h>
#include <qfileinfo.h>
#include <klocale.h>
#include <iostream.h>
#include <assert.h>
#include "cfiles.h"
#include "ctcpclient.h"
#include <kiconloader.h>

//#include "cproject.h"
//#include "vc/versioncontrol.h"
#include "resource.h"

/*********************************************************************
 *                                                                   *
 *                     CREATION RELATED METHODS                      *
 *                                                                   *
 ********************************************************************/


/*------------------------------------- CFiles::CFiles()
 * CFiles()
 *   Constructor.
 *
 * Parameters:
 *   parent         Parent widget.
 *   name           The name of this widget.
 *
 * Returns:
 *   -
 *-----------------------------------------------------------------*/
CFiles::CFiles(QWidget*parent,const char* name)
  : CTreeView(parent,name)
{
	addColumn("");
	addColumn("");
	header()->hide();
	header()->setClickEnabled(false);

  // Create the popupmenus.
  popup = 0;
  showNonPrjFiles=false;
  file_col = 0;
  connect(this,
          SIGNAL(selectionChanged(QListViewItem*)), 
          SLOT(slotSelectionChanged(QListViewItem*)));
	setColumnWidth(1,100);
}

CFiles::~CFiles(){
  if (popup)
      delete popup;
}


/*********************************************************************
 *                                                                   *
 *                          PUBLIC METHODS                           *
 *                                                                   *
 ********************************************************************/

/*------------------------------------------ CFiles::refresh()
 * refresh()
 *   Add all files in the project directory.
 *
 * Parameters:
 *   proj          The project specification.
 *
 * Returns:
 *   -
 *-----------------------------------------------------------------*/

void CFiles::refresh(void)
{
//  assert( prj );
//  project=prj;
  showNonPrjFiles=1;
	if (showNonPrjFiles) {
		setColumnWidthMode(0,Maximum);
		setColumnWidthMode(1,Manual);
		setColumnWidthMode(2,Maximum);
		setColumnWidth(0,0);
		setColumnWidth(1,10);
		setColumnWidth(2,0);
	} else {
		setColumnWidthMode(0,Maximum);
		setColumnWidthMode(1,Manual);
		setColumnWidthMode(2,Maximum);
		setColumnWidth(0,0);
		setColumnWidth(1,10);
		setColumnWidth(2,0);
	}
  // Remove all entries.
  treeH->clear();

  // Add the root item.
//  pRootItem = treeH->addRoot( "", THPROJECT );
//  pRootItem->setOpen(true);

  pRWItem = treeH->addRoot( "Working", THFOLDER );
  pRWItem->setOpen(true);

  pROItem = treeH->addRoot( "Read only", THFOLDER);
  pROItem->setOpen(true);



  setColumnText(0,"Filename");
  setColumnText(2,"Path");
}


/*----------------------------------- CFiles::getCurrentPopup()
 * getCurrentPopup()
 *   Get the current popupmenu.
 *
 * Parameters:
 *   -
 * Returns:
 *   -
 *-----------------------------------------------------------------*/
KPopupMenu *CFiles::getCurrentPopup()
{
	int ckfile;
	QListViewItem *c=currentItem();
	QString msg;
	msg="";
  if (popup)
    delete popup;


  switch( treeH->itemType() )
  {
    case THPROJECT :
			popup = new KPopupMenu(i18n("Project Options"));
      popup->insertItem( i18n("Refresh list"),
                         this, SLOT(slotRemoveFileFromProject()));
//      popup->insertItem( i18n("Refresh list"),
//                         this, SLOT(slotShowNonPrjFiles()), 0, ID_RFV_SHOW_NONPRJFILES );
      popup->setCheckable(true);
   //   if(showNonPrjFiles) popup->setItemChecked(ID_RFV_SHOW_NONPRJFILES, true);
      break;
		case THINSTALLED_FILE:
//      popup = new KPopupMenu(i18n("File (Registered)"));
//      popup->insertItem( i18n("Remove File from Project..."),
//                         this, SLOT(slotRemoveFileFromProject()));
//      popup->insertItem( *(treeH->getIcon( THDELETE )), i18n("Remove File from Disk..."),
//                         this, SLOT(slotDeleteFilePhys()));
//      popup->insertSeparator();
//      popup->insertItem( i18n("Properties..."),
//                         this, SLOT(slotShowFileProperties()));
      break;
		case THC_FILE:
      popup = new KPopupMenu(i18n("File"));
      if(c->parent()==pROItem)
      		ckfile=2;
      else
      		ckfile=1;
//      popup->insertItem( i18n("Add File ..."),
//                         this, SLOT(slotAddFileToProject()));
//	ckfile=checkFile(client,getRelFilename(currentItem()));
//	c=currentItem();
	if(ckfile==0 ){
		popup->insertItem(  i18n("Open for working"),
                         this, SLOT(slotOpenWorkingFile()));
		popup->insertItem(  i18n("Open for read only"),
                         this, SLOT(slotOpenWorkingFile()));
		popup->insertItem(  i18n("Rename file"),
                         this, SLOT(slotDeleteFilePhys()));
	      	popup->insertItem(  i18n("Remove file"),
                         this, SLOT(slotDeleteFilePhys()));
	//	msg="";
	}
	if(ckfile==1 ){
	      popup->insertItem( Icon("filefloppy.xpm"), i18n("Save file"),
                         this, SLOT(slotSaveFile()));
	      popup->insertItem(  i18n("Close file"),
                         this, SLOT(slotCloseFile()));
  //            msg="Lock by me";
	}

	if(ckfile==2 ){
	      popup->insertItem(  i18n("Close file"),
                         this, SLOT(slotCloseFile()));
//              msg="Lock by other";
	}
      break;
    case THFOLDER:
//      if (project->getVersionControl())
//          {
//              popup = new KPopupMenu(i18n("Folder"));
//              popup->insertItem( i18n("Add a file"),
//                                 this, SLOT(slotUpdate()) );
//              popup->insertItem( i18n("Remove directory"),
//                                 this, SLOT(slotCommit()) );
		popup=0;
              break;
//          }
    default:
      popup = 0;
  }

//  VersionControl *vc = project->getVersionControl();
//  if ( (treeH->itemType() == THINSTALLED_FILE || treeH->itemType() == THC_FILE)
//       && vc)
//      {
//          VersionControl::State reg =
//              vc->registeredState(getFullFilename(currentItem()));
//          int id;
//          popup->insertSeparator();
//          id = popup->insertItem( i18n("Update"),
//                                  this, SLOT(slotUpdate()) );
//          popup->setItemEnabled(id, reg & VersionControl::canBeCommited);
//          id = popup->insertItem( i18n("Commit"),
//                                  this, SLOT(slotCommit()) );
//          popup->setItemEnabled(id, reg & VersionControl::canBeCommited);
//          id = popup->insertItem( i18n("Add to Repository"),
//                                  this, SLOT(slotAddToRepository()) );
//          popup->setItemEnabled(id, reg & VersionControl::canBeAdded);
//          id = popup->insertItem( i18n("Remove from Repository (and disk)"),
//                                  this, SLOT(slotRemoveFromRepository()) );
//          popup->setItemEnabled(id, !(reg & VersionControl::canBeAdded));
//      }
              
	c->setText(1,msg);
  return popup;
}

QString CFiles::getRelFilename(QListViewItem* pItem) {

  return pItem->text(2);
}

QString CFiles::getFullFilename(QListViewItem* pItem) {

  return pItem->text(2);
}

bool CFiles::isInstalledFile(QString filename)
{
	int i=0;
	bool b=false;
	i=filelist.contains(filename);
	if ( i>0 ) b=true;
	return b;
}

/*********************************************************************
 *                                                                   *
 *                              SLOTS                                *
 *                                                                   *
 ********************************************************************/

void CFiles::slotSelectionChanged(QListViewItem* selection)
{
//  selection->setText(1,"sdfgsdfg");
  if( mouseBtn == LeftButton && treeH->itemType() != THFOLDER ||
      mouseBtn == MidButton && treeH->itemType() != THFOLDER){
        emit fileSelected(getRelFilename(selection));
}
}

void CFiles::slotSaveFile()
{
  QString filename=getFullFilename(currentItem());
        emit saveFile(filename);
}
void CFiles::slotCloseFile()
{
  QString filename=getFullFilename(currentItem());
        emit scloseFile(filename);
}


void CFiles::slotAddFileToProject() {

  QString filename=getFullFilename(currentItem());
  QString msg;
  msg.sprintf(i18n("Do you want to add the file\n%s\nto the project ?"), filename.data());
  if (KMsgBox::yesNo(0, i18n("Question"), msg, KMsgBox::QUESTION) == 2)
    return;

  emit addFileToProject(filename);
}

void CFiles::slotRemoveFileFromProject() {

  QString filename=getRelFilename(currentItem());
  QString msg;
  msg.sprintf(i18n("Do you really want to remove the file\n%s\nfrom project?\n\t\tIt will remain on disk."), filename.data());
  if (KMsgBox::yesNo(0, i18n("Warning"), msg, KMsgBox::EXCLAMATION) == 2)
    return;

  emit removeFileFromProject(filename);
}

void CFiles::slotDeleteFilePhys() {

  QString filename=getRelFilename(currentItem());
  QString msg;
  msg.sprintf(i18n("Do you really want to delete the file\n%s\nfrom the disk?\nThere is no way to restore it!"), filename.data());
  if(KMsgBox::yesNo(0, i18n("Warning"), msg, KMsgBox::EXCLAMATION) == 2)
    return;

  QFile::remove(getFullFilename(currentItem()));

  if (isInstalledFile(filename)) 
    emit removeFileFromProject(filename);

  refresh();
}

void CFiles::slotShowFileProperties() {
  emit showFileProperties(getRelFilename(currentItem()));
}


void CFiles::slotAddToRepository()
{
//    project->getVersionControl()->add(getFullFilename(currentItem()));
}


void CFiles::slotRemoveFromRepository()
{
//    project->getVersionControl()->remove(getFullFilename(currentItem()));
    refresh();
}
 

void CFiles::slotUpdate()
{
    QString file_dir_name = getFullFilename(currentItem());
    QFileInfo file_info(file_dir_name);
    if (file_info.isFile()){ 
	emit updateFileFromVCS(file_dir_name);
    }
    if(file_info.isDir()){
      emit updateDirFromVCS(file_dir_name);
    }
}


void CFiles::slotCommit()
{
    QString file_dir_name = getFullFilename(currentItem());
    QFileInfo file_info(file_dir_name);
    if (file_info.isFile()){ 
	emit commitFileToVCS(file_dir_name);
    }
    if(file_info.isDir()){
      emit commitDirToVCS(file_dir_name);
    }
}
 
void CFiles::slotShowNonPrjFiles() {
	showNonPrjFiles=!showNonPrjFiles;
	refresh();
}

void CFiles::slotCloseAll() {
	QListViewItem *item, *root;
	QString p;
	root=pROItem;
	item=pROItem->firstChild();
	while(item){
	        p=item->text(2);
		emit scloseFile(p);
		item=item->nextSibling ();

	}
	root=pRWItem;
	item=pRWItem->firstChild();
	while(item){
	        p=item->text(2);
		emit scloseFile(p);
		item=item->nextSibling ();

	}
}

void CFiles::slotLockFile() {
  QString file = getRelFilename(currentItem());
	QString msg;
  QListViewItem *c=currentItem();
  c->setText(1,msg);
//  if(KMsgBox::yesNo(0, i18n("Warning"), msg, KMsgBox::EXCLAMATION) == 2)
//{}
//	refresh();
}

void CFiles::slotOpenWorkingFile() {
  KMsgBox::yesNo(0, i18n("Warning"), "This option is not implemented", KMsgBox::EXCLAMATION);
    return;
  QString file = getRelFilename(currentItem());
	QString msg;
	setColumnWidth(1,100);
  QListViewItem *c=currentItem();
  c->setText(1,msg);
//  if(KMsgBox::yesNo(0, i18n("Warning"), msg, KMsgBox::EXCLAMATION) == 2)
//{}
//	refresh();
}



/**  */
void CFiles::getTcpConnection(){
//  client=NULL;
}

QString getFilename(QString path){
  int len=path.length();
  int index=path.findRev('/',len);
  return path.mid(index+1,len-index);
}

void CFiles::addROFile(QString file){
  QListViewItem* item;

  item = treeH->addItem( getFilename(file),  THINSTALLED_FILE ,pROItem);
//  setColumnWidth(1,100);
  item->setText(2,file);
}

void CFiles::addRWFile(QString file){
  QListViewItem* item;

  item = treeH->addItem( getFilename(file),  THINSTALLED_FILE,pRWItem );
//  setColumnWidth(1,100);
  item->setText(2,file);
}

void CFiles::addFile(QString file, int ck){
	if(ck==2){
		addROFile(file);
	} else {
		addRWFile(file);
	}
}

int CFiles::existFile(QString file ){
	QListViewItem *item, *root;
	QString p;
	root=pROItem;
	item=pROItem->firstChild();
	while(item){
	        p=item->text(2);
		if(p==file){
			return 2;
		}
		item=item->nextSibling ();

	}
	root=pRWItem;
	item=pRWItem->firstChild();
	while(item){
	        p=item->text(2);
		if(p==file){
			return 1;
		}
		item=item->nextSibling ();

	}
return 0;
}

void CFiles::closeFile(QString file ){
	QListViewItem *item, *root;
	QString p;
	root=pROItem;
	item=pROItem->firstChild();
	while(item){
	        p=item->text(2);
		if(p==file){
			pROItem->removeItem(item);
			repaintItem(item);
			repaintItem(pROItem);
			return;
		}
		item=item->nextSibling ();

	}
	root=pRWItem;
	item=pRWItem->firstChild();
	while(item){
	        p=item->text(2);
		if(p==file){
			pRWItem->removeItem(item);
			repaintItem(item);
			repaintItem(pRWItem);
			return;
		}
		item=item->nextSibling ();

	}
}















