/***************************************************************************
                    crealfileview.cpp - 
                             -------------------                                         
                            
    begin                : 9 Sept 1998                                        
    copyright            : (C) 1998 by Stefan Bartel                         
    email                : bartel@rz.uni-potsdam.de                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "qdir.h"
#include "qstrlist.h"
#include <kmsgbox.h>
#include <qfile.h>
#include <qfileinfo.h>
#include <klocale.h>
#include <iostream.h>
#include <assert.h>
#include "crealfileview.h"
#include "ctcpclient.h"
#include <kiconloader.h>

//#include "cproject.h"
//#include "vc/versioncontrol.h"
#include "resource.h"
#include "cgetname.h"

/*********************************************************************
 *                                                                   *
 *                     CREATION RELATED METHODS                      *
 *                                                                   *
 ********************************************************************/


/*------------------------------------- CRealFileView::CRealFileView()
 * CRealFileView()
 *   Constructor.
 *
 * Parameters:
 *   parent         Parent widget.
 *   name           The name of this widget.
 *
 * Returns:
 *   -
 *-----------------------------------------------------------------*/
CRealFileView::CRealFileView(QWidget*parent,const char* name)
  : CTreeView(parent,name)
{
	addColumn("");
	addColumn("");
	header()->hide();
	header()->setClickEnabled(false);

  // Create the popupmenus.
  popup = 0;
  showNonPrjFiles=false;
  file_col = 0;
  connect(this,
          SIGNAL(selectionChanged(QListViewItem*)), 
          SLOT(slotSelectionChanged(QListViewItem*)));
	setColumnWidth(1,0);
}

CRealFileView::~CRealFileView(){
  if (popup)
      delete popup;
  if(client) {
  	quitTCP(client);
  	delete client;
  }
}


/*********************************************************************
 *                                                                   *
 *                          PUBLIC METHODS                           *
 *                                                                   *
 ********************************************************************/

/*------------------------------------------ CRealFileView::refresh()
 * refresh()
 *   Add all files in the project directory.
 *
 * Parameters:
 *   proj          The project specification.
 *
 * Returns:
 *   -
 *-----------------------------------------------------------------*/

void CRealFileView::refresh(void)
{
//  assert( prj );
//  project=prj;
  showNonPrjFiles=1;
	if (showNonPrjFiles) {
		setColumnWidthMode(0,Maximum);
//		setColumnWidthMode(1,Manual);
//		setColumnWidthMode(2,Manual);
		setColumnWidth(0,0);
//		setColumnWidth(1,0);
//		setColumnWidth(2,0);
	} else {
		setColumnWidthMode(0,Maximum);
//		setColumnWidthMode(1,Manual);
//		setColumnWidthMode(2,Manual);
		setColumnWidth(0,0);
//		setColumnWidth(1,0);
//		setColumnWidth(2,0);
	}
  if(client){
//  QString projectdir="Root";
//  if(projectdir.right(1)=="/") {
//    projectdir.truncate(projectdir.length()-1);
//  }
//  this->projectDir=projectdir;
//  QDir dir(projectdir);
//  if (!dir.exists()) {
//    return;
//  }

  // Remove all entries.
  treeH->clear();

  // Save all files registered in the project in the filelist variable.
//  project->getAllFiles(filelist);

  // Add the root item.
  pRootItem = treeH->addRoot( projectdir, THPROJECT );
  pRootItem->setOpen(true);

//  scanDir(projectdir, pRootItem);
//   getTcpConnection();
//   setProject(client,"RIAL");
   QString d("");
//   d=new QString("SAD");
   scanDirFromTCP(d,pRootItem);	
 }
}

void CRealFileView::addFilesFromDir( const QString& directory, QListViewItem* parent ) {

    QDir theDir( directory );
    QStrList fl;
    QListViewItem* item;
    QString f;
    QString d=directory;
    d.remove(0,projectDir.length());
  //  VersionControl* vc;
  //  VersionControl::State reg;

    // Add all files for this directory
    theDir.setFilter(QDir::Files);
    fl=*(theDir.entryList());

		for( fl.first(); fl.current(); fl.next() ) {
				f=d;
        f.append("/");
				f.append(fl.current());
        f.remove(0,1);
				if( isInstalledFile(f) ) {
						item = treeH->addItem( fl.current(), THINSTALLED_FILE, parent);
						if (showNonPrjFiles) {
//								item->setText(1,i18n("registered"));
						//		vc=project->getVersionControl();
						//		if (vc!=0) {
//										reg=vc->registeredState(directory+'/'+fl.current());
						//				if (reg & VersionControl::canBeCommited) {
						//						item->setText(2,i18n("VCS"));
						//				} else {
						//						item->setText(2,i18n("local"));
						//				}
						//		}
						}
				} else {
						if (showNonPrjFiles) {
								item = treeH->addItem( fl.current(), THC_FILE, parent,i18n("registered") );
						//		vc=project->getVersionControl();
//								if (vc!=0) {
							//			reg=vc->registeredState(directory+'/'+fl.current());
//										if (reg & VersionControl::canBeCommited) {
	//											item->setText(2,i18n("VCS"));
//										} else {
//												item->setText(2,i18n("local"));
//										}
//								}
//						}
				}
   	}
}
}

void CRealFileView::scanDir(const QString& directory, QListViewItem* parent) 
{
  QString currentPath;
  QListViewItem* lastFolder;
  QStrList dirList;
  QDir dir(directory);

  // Stop recursion if the directory doesn't exist.
  if (!dir.exists()) {
    return;
  }

  dir.setSorting(QDir::Name);
  dir.setFilter(QDir::Dirs);
  dirList = *(dir.entryList());
  
  // Remove '.' and  '..'
  dirList.first();
  dirList.remove();
  dirList.remove();

  // Recurse through all directories
  while( dirList.current() ) 
  {
    lastFolder = treeH->addItem( dirList.current(), THFOLDER, parent );
    lastFolder->setOpen( false );
    
    // Recursive call to fetch subdirectories
    currentPath = directory+"/"+dirList.current();
    scanDir( currentPath, lastFolder );
    
    // Add the files in the recursed directory.
    //    addFilesFromDir( currentPath, lastFolder );
    
    treeH->setLastItem( lastFolder );
    
    dirList.next();
  } 
  
  // Add files in THIS directory as well.
  addFilesFromDir( directory, parent );
}

/*----------------------------------- CRealFileView::getCurrentPopup()
 * getCurrentPopup()
 *   Get the current popupmenu.
 *
 * Parameters:
 *   -
 * Returns:
 *   -
 *-----------------------------------------------------------------*/
KPopupMenu *CRealFileView::getCurrentPopup()
{
	int ckfile;
	QListViewItem *c=currentItem();
	QString msg;
	msg="";
  if (popup)
    delete popup;


  switch( treeH->itemType() )
  {
    case THPROJECT :
			popup = new KPopupMenu(i18n("Project root folder"));
      popup->insertItem( i18n("Refresh list"),
                         this, SLOT(slotRefresh()));
      popup->insertItem( i18n("Add a folder"),
                         this, SLOT(slotAddFolder()));
      popup->insertItem( i18n("Add a file"),
                         this, SLOT(slotAddFile()));
//      popup->insertItem( i18n("Refresh list"),
//                         this, SLOT(slotShowNonPrjFiles()), 0, ID_RFV_SHOW_NONPRJFILES );
   //   if(showNonPrjFiles) popup->setItemChecked(ID_RFV_SHOW_NONPRJFILES, true);
      break;
		case THINSTALLED_FILE:
      popup=0;
      break;
		case THC_FILE:
      popup = new KPopupMenu(i18n("File"));
//      popup->insertItem( i18n("Add File ..."),
//                         this, SLOT(slotAddFileToProject()));
	ckfile=checkFile(client,getRelFilename(currentItem()));
//	c=currentItem();
	if(ckfile==0 ){
		if(opened->existFile(getRelFilename(currentItem()))==2){
		popup->insertItem(  i18n("Close"),
                         this, SLOT(slotClose()));
		popup->insertItem( Icon("fileopen.xpm"), i18n("Close and reopen"),
                         this, SLOT(slotOpenForWorking()));
		} else {
		popup->insertItem( Icon("fileopen.xpm"), i18n("Open"),
                         this, SLOT(slotOpen()));
//		popup->insertItem( i18n("Rename file"),
  //                       this, SLOT(slotRenameFile()));
	      	popup->insertItem(  i18n("Remove file"),
                         this, SLOT(slotRemoveFile()));
                }
	//	msg="";
	}
	if(ckfile==1 ){
		if(opened->existFile(getRelFilename(currentItem()))==0){
		popup->insertItem( Icon("fileopen.xpm"), i18n("Open"),
                         this, SLOT(slotOpen()));
		popup->insertItem( i18n("Unlock"),
                         this, SLOT(slotUnLockFile()));

		} else {
		if(opened->existFile(getRelFilename(currentItem()))==2){
		popup->insertItem(  i18n("Close"),
                         this, SLOT(slotClose()));
		popup->insertItem( Icon("fileopen.xpm"), i18n("Open for working"),
                         this, SLOT(slotOpenForWorking()));
		popup->insertItem( i18n("Unlock"),
                         this, SLOT(slotUnLockFile()));
		} else {
	      popup->insertItem( Icon("filefloppy.xpm"), i18n("Save"),
                         this, SLOT(slotSave()));
	      popup->insertItem(  i18n("Close"),
                         this, SLOT(slotClose()));
              }
              }
  //            msg="Lock by me";
	}

	if(ckfile==2 ){
		if(opened->existFile(getRelFilename(currentItem()))==2){
		popup->insertItem( Icon("fileopen.xpm"), i18n("Close"),
                         this, SLOT(slotClose()));
		} else {
		      popup->insertItem( Icon("fileopen.xpm"), i18n("Open for read only"),
        	                 this, SLOT(slotOpen()));
        	 }
//              msg="Lock by other";
	}
      break;
    case THFOLDER:
//      if (project->getVersionControl())
//          {
              popup = new KPopupMenu(i18n("Folder"));
              popup->insertItem( i18n("Add a folder"),
                                 this, SLOT(slotAddFolder()) );
              popup->insertItem( i18n("Add a file"),
                                 this, SLOT(slotAddFile()) );
//              popup->insertItem( i18n("Rename folder"),
//                                 this, SLOT(slotRenameFolder()) );
              popup->insertItem( i18n("Remove folder"),
                                 this, SLOT(slotRemoveFolder()) );
              break;
//          }
    default:
      popup = 0;
  }

//  VersionControl *vc = project->getVersionControl();
//  if ( (treeH->itemType() == THINSTALLED_FILE || treeH->itemType() == THC_FILE)
//       && vc)
//      {
//          VersionControl::State reg =
//              vc->registeredState(getFullFilename(currentItem()));
//          int id;
//          popup->insertSeparator();
//          id = popup->insertItem( i18n("Update"),
//                                  this, SLOT(slotUpdate()) );
//          popup->setItemEnabled(id, reg & VersionControl::canBeCommited);
//          id = popup->insertItem( i18n("Commit"),
//                                  this, SLOT(slotCommit()) );
//          popup->setItemEnabled(id, reg & VersionControl::canBeCommited);
//          id = popup->insertItem( i18n("Add to Repository"),
//                                  this, SLOT(slotAddToRepository()) );
//          popup->setItemEnabled(id, reg & VersionControl::canBeAdded);
//          id = popup->insertItem( i18n("Remove from Repository (and disk)"),
//                                  this, SLOT(slotRemoveFromRepository()) );
//          popup->setItemEnabled(id, !(reg & VersionControl::canBeAdded));
//      }
              
//	c->setText(1,msg);
  return popup;
}

QString CRealFileView::getRelFilename(QListViewItem* pItem) {

  QString filename("");//pItem->text(file_col);

  if (pItem != pRootItem) {
    filename+=pItem->text(file_col);
    pItem=pItem->parent();
  }
  while (pItem != pRootItem) {
    if(!(filename.isNull() || filename.isEmpty())) {
	    filename = QString(pItem->text(file_col))+ "/" + filename;
	 } else {
	    filename = QString(pItem->text(file_col));
	 }
    pItem = pItem->parent();
  }
  return filename;
}

QString CRealFileView::getFullFilename(QListViewItem* pItem) {

  QString filename = pItem->text(file_col);
  while (pItem != pRootItem) {
    pItem = pItem->parent();
    filename = QString(pItem->text(file_col)) + "/" + filename;
  }
  return filename;
}

bool CRealFileView::isInstalledFile(QString filename) 
{
	int i=0;
	bool b=false;
	i=filelist.contains(filename);
	if ( i>0 ) b=true;
	return b;
}

/*********************************************************************
 *                                                                   *
 *                              SLOTS                                *
 *                                                                   *
 ********************************************************************/

void CRealFileView::slotSelectionChanged(QListViewItem* selection) 
{
//  selection->setText(1,"sdfgsdfg");
//	int ckfile;
//	QString msg;
  if( mouseBtn == LeftButton && treeH->itemType() != THFOLDER ||
      mouseBtn == MidButton && treeH->itemType() != THFOLDER){
        emit fileSelected(getRelFilename(selection));
//				ckfile=checkFile(client,getRelFilename(currentItem()));
//				if(ckfile==1){
//					msg="Lock by me";
//				}
//				if(ckfile==2){
//					msg="Lock by other";
//				}
				
//			  setColumnWidth(1,100);
// 		 		selection->setText(1,msg);
}
}

void CRealFileView::slotAddFileToProject() {

  QString filename=getFullFilename(currentItem());
  QString msg;
  msg.sprintf(i18n("Do you want to add the file\n%s\nto the project ?"), filename.data());
  if (KMsgBox::yesNo(0, i18n("Question"), msg, KMsgBox::QUESTION) == 2)
    return;

  emit addFileToProject(filename);
}

void CRealFileView::slotRemoveFileFromProject() {

  if(KMsgBox::yesNo(0, i18n("Warning"), "This option is not implemented", KMsgBox::EXCLAMATION))
    return;
  QString filename=getRelFilename(currentItem());
  QString msg;
  msg.sprintf(i18n("Do you really want to remove the file\n%s\nfrom project?\n\t\tIt will remain on disk."), filename.data());
  if (KMsgBox::yesNo(0, i18n("Warning"), msg, KMsgBox::EXCLAMATION) == 2)
    return;

  emit removeFileFromProject(filename);
}

void CRealFileView::slotDeleteFilePhys() {
  KMsgBox::yesNo(0, i18n("Warning"), "This option is not implemented", KMsgBox::EXCLAMATION);
    return;

  QString filename=getRelFilename(currentItem());
  QString msg;
  msg.sprintf(i18n("Do you really want to delete the file\n%s\nfrom the disk?\nThere is no way to restore it!"), filename.data());
  if(KMsgBox::yesNo(0, i18n("Warning"), msg, KMsgBox::EXCLAMATION) == 2)
    return;

  QFile::remove(getFullFilename(currentItem()));

  if (isInstalledFile(filename)) 
    emit removeFileFromProject(filename);

  refresh();
}

void CRealFileView::slotShowFileProperties() {
  emit showFileProperties(getRelFilename(currentItem()));
}


void CRealFileView::slotAddToRepository()
{
//    project->getVersionControl()->add(getFullFilename(currentItem()));
}


void CRealFileView::slotRemoveFromRepository()
{
//    project->getVersionControl()->remove(getFullFilename(currentItem()));
    refresh();
}
 

void CRealFileView::slotUpdate()
{
    QString file_dir_name = getFullFilename(currentItem());
    QFileInfo file_info(file_dir_name);
    if (file_info.isFile()){ 
	emit updateFileFromVCS(file_dir_name);
    }
    if(file_info.isDir()){
      emit updateDirFromVCS(file_dir_name);
    }
}


void CRealFileView::slotSave()
{
    QString file_dir_name = getRelFilename(currentItem());
//    QFileInfo file_info(file_dir_name);
	emit saveFile(file_dir_name);
}

void CRealFileView::slotOpen()
{
    QString file_dir_name = getRelFilename(currentItem());
//    QFileInfo file_info(file_dir_name);
	emit fileSelected(file_dir_name);
}

void CRealFileView::slotOpenForWorking()
{
    QString file_dir_name = getRelFilename(currentItem());
//    QFileInfo file_info(file_dir_name);
	emit closeFile(file_dir_name);
	emit fileSelected(file_dir_name);
}

void CRealFileView::slotClose()
{
    QString file_dir_name = getRelFilename(currentItem());
//    QFileInfo file_info(file_dir_name);
	emit closeFile(file_dir_name);
}

void CRealFileView::slotShowNonPrjFiles() {
	showNonPrjFiles=!showNonPrjFiles;
	refresh();
}

void CRealFileView::slotLockFile() {
  QString file = getRelFilename(currentItem());
	QString msg;
	if(lockFile(client,file)==1){
		msg="Lock by me";	
	} else{
		msg="Lock by other";
	}
  QListViewItem *c=currentItem();
//  c->setText(1,msg);
//  if(KMsgBox::yesNo(0, i18n("Warning"), msg, KMsgBox::EXCLAMATION) == 2)
//{}
//	refresh();
}

void CRealFileView::slotUnLockFile() {
  QString file = getRelFilename(currentItem());
  unlockFile(client,file);

//  if(KMsgBox::yesNo(0, i18n("Warning"), msg, KMsgBox::EXCLAMATION) == 2)
//{}
//	refresh();
}

void CRealFileView::slotOpenWorkingFile() {
  QString file = getRelFilename(currentItem());
	QString msg;
	if(lockFile(client,file)==1){
		msg="Open for working";	
	} else{
		msg="Lock by other";
	}
	setColumnWidth(1,0);
  QListViewItem *c=currentItem();
//  c->setText(1,msg);
//  if(KMsgBox::yesNo(0, i18n("Warning"), msg, KMsgBox::EXCLAMATION) == 2)
//{}
//	refresh();
}


/**  */
void CRealFileView::scanDirFromTCP(const QString& directory, QListViewItem* parent){

  QString currentPath,current;
  QListViewItem* lastFolder;
  QString dirList=getDirsFromDir(client,directory);
  int ind, index;

//  if (dirList.right(2)=="//" ){
//  	dirList+="//";
//  }
//  QStrList dirList;
//  QDir dir(directory);

  // Stop recursion if the directory doesn't exist.
//  if (!dir.exists()) {
//    return;
//  }

//  dir.setSorting(QDir::Name);
//  dir.setFilter(QDir::Dirs);
// dirList = *(dir.entryList());

  // Remove '.' and  '..'
//  dirList.first();
//  dirList.remove();
//  dirList.remove();

  // Recurse through all directories
  index=0;
//  cout << "directory " << directory << endl;
//  cout << " list " << dirList << endl;
	QString dirlock("KPHPDEV.LOCK");
  while( (ind=dirList.find("//",index))!=-1 )
  {
    current=dirList.mid(index,ind-index);
    index=ind+2;
//    cout << current << endl;
    if(current!=dirlock){
    lastFolder = treeH->addItem( current, THFOLDER, parent );
    lastFolder->setOpen( false );

    // Recursive call to fetch subdirectories
    currentPath = directory+"/"+current;
//    cout  << "deep in " << currentPath <<endl;
    scanDirFromTCP( currentPath, lastFolder );

    // Add the files in the recursed directory.
        addFilesFromDirTCP( currentPath, lastFolder );
    treeH->setLastItem( lastFolder );
    }

//    dirList.next();
  }

  // Add files in THIS directory as well.
//  cerr << "Files from root " << endl;
if(parent==pRootItem)
  addFilesFromDirTCP( directory, parent );

}

void CRealFileView::addFilesFromDirTCP( const QString& directory, QListViewItem* parent ) {

    QDir theDir( directory );
    QStrList fl;
    QListViewItem* item;
    QString f,current;
    QString d=directory;
//    d.remove(0,projectDir.length());
    QString filesList=getFilesFromDir(client,directory);
    int ind, index;

//  if (filesList.right(2)=="//" ){
//  	filesList+="//";
//  }
  //  VersionControl* vc;
  //  VersionControl::State reg;

    // Add all files for this directory
 //   theDir.setFilter(QDir::Files);
//    fl=*(theDir.entryList());

//		for( fl.first(); fl.current(); fl.next() ) {
	index=0;
	while((ind=filesList.find("//",index))!=-1){				
				current=filesList.mid(index,ind-index);
				index=ind+2;
				f=d;
        			f.append("/");
				f.append(current);
			        //f.remove(0,1);
//				item = treeH->addItem( current, THINSTALLED_FILE, parent);
				if( /*isInstalledFile(f)*/ 1==0 ) {
						item = treeH->addItem( current, THINSTALLED_FILE, parent);
						if (showNonPrjFiles) {
//								item->setText(1,i18n(""));
						//		vc=project->getVersionControl();
						//		if (vc!=0) {
//										reg=vc->registeredState(directory+'/'+fl.current());
						//				if (reg & VersionControl::canBeCommited) {
						//						item->setText(2,i18n("VCS"));
						//				} else {
						//						item->setText(2,i18n("local"));
						//				}
						//		}
						}
				} else {
						if (showNonPrjFiles) {
								item = treeH->addItem( current, THC_FILE, parent,i18n("") );
						//		vc=project->getVersionControl();
//								if (vc!=0) {
							//			reg=vc->registeredState(directory+'/'+fl.current());
//										if (reg & VersionControl::canBeCommited) {
	//											item->setText(2,i18n("VCS"));
//										} else {
//												item->setText(2,i18n("local"));
//										}
//								}
//						}
				}
   	}
}
}

/**  */
void CRealFileView::getTcpConnection(){
  client=NULL;
}

/**  */
void CRealFileView::slotRefresh(){
	refresh();
}

/**  */
void CRealFileView::slotAddFolder(){
//  KMsgBox::yesNo(0, i18n("Warning"), "This option is not implemented", KMsgBox::EXCLAMATION);
  CGetName ask(2,this);
  int i=ask.exec();
  if(i){
  	  QString f;
  	  if(currentItem()!=pRootItem)
	  	  f=getRelFilename(currentItem())+"/"+ask.name->text();
	  else
	  	  f=ask.name->text();
	  addFolder(client,f);
	  refresh();
  }
//    return;
}

/**  */
void CRealFileView::slotAddFile(){
//  KMsgBox::yesNo(0, i18n("Warning"), "This option is not implemented", KMsgBox::EXCLAMATION);
  CGetName ask(1,this);
  int i=ask.exec();
  if(i){
  	  QString f;
  	  f=getRelFilename(currentItem())+"/"+ask.name->text();
	  addFile(client,f);
	  refresh();
  }
//    return;
}

/**  */
void CRealFileView::slotRenameFile(){
  KMsgBox::message(0, i18n("Warning"), "This option is not implemented", KMsgBox::EXCLAMATION);
    return;
}

/**  */
void CRealFileView::slotRemoveFile(){
  if(KMsgBox::yesNo(0, i18n("Warning"), "Do you want to delete this file ?", KMsgBox::EXCLAMATION)==2)
	   return;
  delFile(client,getRelFilename(currentItem()));
  refresh();
}

/**  */
void CRealFileView::slotRemoveFolder(){
  if(KMsgBox::yesNo(0, i18n("Warning"), "Do you want to remove this folder recursively ?", KMsgBox::EXCLAMATION)==2)
	   return;
  delFolder(client,getRelFilename(currentItem()));
  refresh();
}

/**  */
void CRealFileView::slotRenameFolder(){
  KMsgBox::message(0, i18n("Warning"), "This option is not implemented", KMsgBox::EXCLAMATION);
    return;
}




