/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kapp.h>
#include "DialogPref.h"

DialogPref::DialogPref(QWidget *parent)
  : DialogPrefData(parent, 0)
  {
  setCaption(i18n("KMySql settings"));
  QIntValidator *v = new QIntValidator(edit_nbsaved);
  edit_nbsaved->setValidator(v);
  }

void DialogPref::setFields(Pref pref)
  {
  saveq->setChecked(pref.savequit);
  QString s;
  s.setNum(pref.nbsaved);
  edit_nbsaved->setText(s);
  combo_historyAction->setCurrentItem(pref.historyBehaviour);
  comboErrors->setCurrentItem(pref.errorsDestination);
  autoUpdates->setChecked(pref.autoUpdates);
  autoDetectPlugins->setChecked(pref.autoDetectPlugins);
  }

void DialogPref::ok(void)
  {
  done(1);
  }

void DialogPref::cancel(void)
  {
  done(0);
  }

Pref DialogPref::getResult(void)
  {
  Pref res;
  res.savequit = saveq->isChecked();
  QString s = edit_nbsaved->text();
  res.nbsaved = s.toInt();
  res.historyBehaviour = combo_historyAction->currentItem();
  res.errorsDestination = comboErrors->currentItem();
  res.autoUpdates = autoUpdates->isChecked();
	res.autoDetectPlugins = autoDetectPlugins->isChecked();
  return res;
  }






