/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kapp.h>
#include "DialogSelect.h"

#define Inherited DialogSelectData

DialogSelect::DialogSelect(QWidget* parent,	QString table, const char* name)
	:	Inherited( parent, name )
	{
	setCaption(i18n("Select wizard"));
	from->setText(table);
	}

DialogSelect::~DialogSelect(void)
	{
	}

QString DialogSelect::getQuery(void)
	{
	QString select = this->select->text();
	QString from = this->from->text();
	QString where = this->where->text();
	QString having = this->having->text();
	QString groupby = this->groupby->text();
	QString orderby = this->orderby->text();
	QString query;
	query += "SELECT " + select;
	query += " FROM " + from;
	if(!where.isEmpty())
		query += " WHERE " + where;
	if(!having.isEmpty())
		query += " HAVING " + having;
	if(!groupby.isEmpty())
		query += " GROUP BY " + groupby;
	if(!orderby.isEmpty())
		query += " ORDER BY " + orderby;
	return query;
	}

