/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DialogTableField_included
#define DialogTableField_included

#include <qstring.h>
#include <qvalidator.h>
#include <qmessagebox.h>
#include "DialogTableFieldData.h"


class TableField
  {
  public:
		QString toSQL();
    QString name;
   	QString defaultValue;
    QString type;
    bool specDefaultValue;
    bool specLength;
    bool specDecimals;
    bool canNull;
    bool autoIncrement;
    int length;
    int decimals;
    bool binary;
    bool isUnsigned;
    bool zeroFill;
    bool isKey;    
  };

class DialogTableField : public DialogTableFieldData
  {
    Q_OBJECT
  public:
    DialogTableField(QWidget* parent = NULL, const char* name = NULL);
    virtual ~DialogTableField();
    TableField *result(void);
  	void initFields(TableField *);
  	void setPrimaryKeyEnabled(bool);
  private:
	  void setTypeCombo(QString);
    void initFields(void);
  private slots:
    void typeChanged(int);
    void specLengthChanged();
    void specDefaultValueChanged();
    void isKeyChanged(bool);
    void ok(void);
  private:
  	QIntValidator *intValidator;
  	QDoubleValidator *doubleValidator;
  };

#endif 



