/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "connection.h"

Connection::Connection(ISqlServer *_sql, const char *pluginPath, const char *pluginName, const char *host, const char *login, const char *passwd, int port)
  : login(strdup(login)), passwd(strdup(passwd)), host(strdup(host)), _sql(_sql), pluginName(pluginName), pluginPath(pluginPath), port(port)
  {
  }

Connection::~Connection(void)
  {
  if(_sql)
    delete _sql;
  }

ISqlServer *Connection::sql(void) const
  {
  return _sql;
  }

QString Connection::getName(void) const
  {
  QString res(512);
  if(port != 0)
	  res.sprintf("%s://%s@%s:%d", (const char *)pluginName.lower(), (const char *)login, (const char *)host, port);
	else
		res.sprintf("%s://%s@%s", (const char *)pluginName.lower(), (const char *)login, (const char *)host);
  return res;
  }

QueryResult Connection::connect(void)
  {
  return _sql->connect(host, login, passwd, port);
  }

QueryResult Connection::connect(QString thePasswd)
	{
	return _sql->connect(host, login, thePasswd, port);
	}






