/***************************************************************************
																connection.h
                             -------------------

    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONNECTION_H
#define CONNECTION_H

#include <qstring.h>
#include "isqlserver.h"

class Connection
  {
  public:
    Connection(ISqlServer *, const char *, const char *, const char *, const char *, const char *, int);
    ~Connection(void);
    QueryResult connect(void);
    QueryResult connect(QString);
    ISqlServer *sql(void) const;
    QString getName(void) const;
    QString getLogin(void) { return login; }
    QString getPassword(void) { return passwd; }
    QString getHost(void) { return host; }
    QString getPluginName(void) { return pluginName; }
    int getPort(void) { return port; }
    void setPassword(QString p) { passwd = p; }
  private:
    QString login, passwd, host;
    ISqlServer *_sql;
    QString pluginName;
    QString pluginPath;
    int port;
  };


#endif // CONNECTION_H



