/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "connectionmanager.h"

ConnectionManager *ConnectionManager::instance = 0;

ConnectionManager::ConnectionManager(void)
	{
	if(instance == 0)
		instance = this;
	else
		warning("Multiple instance of ConnectionManager not allowed!");
	connections.setAutoDelete(true);
	}

ConnectionManager::~ConnectionManager(void)
	{
	}

ConnectionManager *ConnectionManager::getInstance(void)
	{
	return instance;
	}

int ConnectionManager::addConnection(Connection *conn)
  {
  if(connectionByName(conn->getName()) != NULL)
  	return 1;
  connections.append(conn);
  return 0;
  }

int ConnectionManager::removeConnection(Connection *conn)
	{
	if(!conn)
		return 1;
	if(conn->sql()->isConnected())
		conn->sql()->close();
	connections.removeRef(conn);
	return 0;
	}

Connection *ConnectionManager::connectionByName(QString name)
  {
  for(unsigned int i=0; i<connections.count(); i++)
    {
    Connection *conn = connections.at(i);
    if(conn->getName() == name)
      return conn;
    }
  return NULL;
  }

unsigned int ConnectionManager::count(void)
	{
	return connections.count();
	}

Connection *ConnectionManager::at(unsigned int i)
	{
	return connections.at(i);
	}	

Connection *ConnectionManager::first(void)
	{
	return connections.first();
	}
	
Connection *ConnectionManager::next(void)
	{
	return connections.next();
	}
	
	
	
	


