/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONNECTIONMANAGER_H
#define CONNECTIONMANAGER_H

#include <qlist.h>
#include "connection.h"

class ConnectionManager
	{
	public:
		ConnectionManager(void);
		~ConnectionManager(void);
		static ConnectionManager *getInstance(void);
		int addConnection(Connection *);
    int removeConnection(Connection *);
    Connection *connectionByName(QString);
    unsigned int count(void);
    Connection *at(unsigned int);
    Connection *first(void);
    Connection *next(void);
	private:
		QList<Connection> connections;
		static ConnectionManager *instance;
	};

#endif










