/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dlgfeconfig.h"

DlgFeConfig::DlgFeConfig(QWidget *parent)
	: QDialog(parent, 0, true)
	{
	initDialog();	
	connect(btnOk, SIGNAL(clicked()), this, SLOT(accept()));
	connect(btnCancel, SIGNAL(clicked()), this, SLOT(reject()));	
	load();
	}

DlgFeConfig::~DlgFeConfig(void)
	{
	}
	
void DlgFeConfig::load(void)
	{
	spinGridSize->setValue(FeGrid::step());
	cbGridVisible->setChecked(FeGrid::isVisible());
	cbGridFit->setChecked(FeGrid::isFit());
	}
	
void DlgFeConfig::save(void)
	{
	FeGrid::setStep(spinGridSize->value());
	FeGrid::setVisible(cbGridVisible->isChecked());
	FeGrid::setFit(cbGridFit->isChecked());
	}




