/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dlgfepropcheckbox.h"
#include "feframe.h"
#include <qobjectlist.h>
#include <qmessagebox.h>
#include <kapp.h>

DlgFePropCheckBox::DlgFePropCheckBox(QWidget *parent, FeCheckBox *cb)
	: QDialog(parent, 0, true)
	{
	initDialog();
	connect(btnOk, SIGNAL(clicked()), this, SLOT(slotOk()));
	connect(btnCancel, SIGNAL(clicked()), this, SLOT(reject()));
	connect(btnHelp, SIGNAL(clicked()), this, SLOT(help()));
	//
	checkBox = cb;
	load();
	}

DlgFePropCheckBox::~DlgFePropCheckBox(void)
	{
	}

void DlgFePropCheckBox::help(void)
	{
	KApplication::getKApplication()->invokeHTMLHelp("kmysql/index.html", "WidgetCheckBox");
	}

void DlgFePropCheckBox::slotOk()
	{
	FeFrame *frame = (FeFrame *)checkBox->parentWidget();
	if(frame->nameExists(editName->text(), checkBox))
		QMessageBox::warning(this, i18n("Name clash"), i18n("This name is already used by another widget\nPlease choose another one."));
	else
		accept();
	}
	
void DlgFePropCheckBox::save(void)
	{
	checkBox->setName(editName->text());
	checkBox->setText(editText->text());
	checkBox->setInitialState(cbInitialState->isChecked());
	checkBox->setValues(editChecked->text(), editUnchecked->text());
	}
	
void DlgFePropCheckBox::load(void)
	{
	editName->setText(checkBox->name());
	editText->setText(checkBox->text());
	cbInitialState->setChecked(checkBox->initialState());
	editChecked->setText(checkBox->checkedValue());
	editUnchecked->setText(checkBox->uncheckedValue());
	}





