/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dlgfepropdate.h"
#include "feframe.h"
#include <qobjectlist.h>
#include <qmessagebox.h>

DlgFePropDate::DlgFePropDate(QWidget *parent, FeDate *date)
	: QDialog(parent, 0, true), date(date)
	{
	initDialog();
	connect(btnOk, SIGNAL(clicked()), this, SLOT(slotOk()));
	connect(btnCancel, SIGNAL(clicked()), this, SLOT(reject()));
	connect(btnHelp, SIGNAL(clicked()), this, SLOT(help()));
	load();
	}

DlgFePropDate::~DlgFePropDate()
	{
	}

void DlgFePropDate::help(void)
	{
	KApplication::getKApplication()->invokeHTMLHelp("kmysql/index.html", "WidgetDate");
	}	

void DlgFePropDate::slotOk()
	{
	FeFrame *frame = (FeFrame *)date->parentWidget();
	if(frame->nameExists(editName->text(), date))
		QMessageBox::warning(this, i18n("Name clash"), i18n("This name is already used by another widget\nPlease choose another one."));
	else
		accept();
	}
	
void DlgFePropDate::load(void)
	{
	editName->setText(date->name());
	}
	
	
void DlgFePropDate::save(void)
	{
	date->setName(editName->text());
	}
	







