/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dlgfepropedit.h"
#include "feframe.h"
#include <qobjectlist.h>
#include <qmessagebox.h>
#include <kapp.h>


DlgFePropEdit::DlgFePropEdit(QWidget *parent, FeEdit *ed)
	: QDialog(parent, 0, true)
	{
	initDialog();
	connect(btnOk, SIGNAL(clicked()), this, SLOT(slotOk()));
	connect(btnCancel, SIGNAL(clicked()), this, SLOT(reject()));
	connect(btnHelp, SIGNAL(clicked()), this, SLOT(help()));
	//
	edit = ed;
	load();
	}

DlgFePropEdit::~DlgFePropEdit(void)
	{
	}
	
void DlgFePropEdit::help(void)
	{
	KApplication::getKApplication()->invokeHTMLHelp("kmysql/index.html", "WidgetEdit");
	}
	
void DlgFePropEdit::slotOk()
	{
	FeFrame *frame = (FeFrame *)edit->parentWidget();
	if(frame->nameExists(editName->text(), edit))
		QMessageBox::warning(this, i18n("Name clash"), i18n("This name is already used by another widget\nPlease choose another one."));
	else
		accept();
	}

void DlgFePropEdit::save(void)
	{
	edit->setName(editName->text());
	edit->setDefaultValue(editDefault->text());
	}
	
void DlgFePropEdit::load(void)
	{
	editName->setText(edit->name());
	editDefault->setText(edit->defaultValue());
	}





