/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "dlgfeproplabel.h"
#include "feframe.h"
#include <qobjectlist.h>
#include <qmessagebox.h>
#include <kapp.h>

DlgFePropLabel::DlgFePropLabel(QWidget *parent, FeLabel *lbl)
	: QDialog(parent, 0, true)
	{
	initDialog();
	connect(btnOk, SIGNAL(clicked()), this, SLOT(slotOk()));
	connect(btnCancel, SIGNAL(clicked()), this, SLOT(reject()));
	connect(btnHelp, SIGNAL(clicked()), this, SLOT(help()));
	//
	label = lbl;
	load();	
	}

DlgFePropLabel::~DlgFePropLabel()
	{
	}

void DlgFePropLabel::help(void)
	{
	KApplication::getKApplication()->invokeHTMLHelp("kmysql/index.html", "WidgetLabel");
	}	
		
void DlgFePropLabel::slotOk()
	{
	FeFrame *frame = (FeFrame *)label->parentWidget();
	if(frame->nameExists(editName->text(), label))
		QMessageBox::warning(this, i18n("Name clash"), i18n("This name is already used by another widget\nPlease choose another one."));
	else
		accept();
	}

void DlgFePropLabel::save(void)
	{
	label->setName(editName->text());
	label->setText(editText->text());
	}
	
void DlgFePropLabel::load(void)
	{
	editName->setText(label->name());
	editText->setText(label->text());
	}



