/***************************************************************************
                          FILENAME  -  description                              
                             -------------------                                         
    begin                : DATE                                           
    copyright            : (C) YEAR by AUTHOR                         
    email                : EMAIL                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include <qvalidator.h>
#include <cstdlib>
#include "dlgserver.h"


DlgServer::DlgServer(PluginManager *pm, QWidget *parent, const char *name)
	: QDialog(parent,name,true)
	{
	initDialog();
	setCaption( "Add server..." );
	pluginManager = pm;
	QStrList *pluginNames = pm->getPluginNames();
	stype->clear();
	stype->insertStrList(pluginNames);
	passwd->setEchoMode(QLineEdit::Password);
	connect(btnOk, SIGNAL(clicked()), this, SLOT(accept()));
	connect(btnCancel, SIGNAL(clicked()), this, SLOT(reject()));
	connect(defaultPort, SIGNAL(toggled(bool)), this, SLOT(defaultPortToggled(bool)));
	QIntValidator *portValidator = new QIntValidator(0, 999999, port);
	port->setValidator(portValidator);
	user->setText(getenv("USER"));
	delete pluginNames;
	}

DlgServer::~DlgServer()
	{
	}

void DlgServer::defaultPortToggled(bool b)
	{
	port->setEnabled(!b);
	}
	
Connection *DlgServer::result()
	{
	int id = pluginManager->getPluginByName(stype->text(stype->currentItem()));
	ISqlServer *sql = pluginManager->createInstance(id);
	const char *pname = pluginManager->getPluginName(id);
	const char *ppath = pluginManager->getPluginPath(id);
	bool b;	
	int port;
	if(defaultPort->isChecked())
		port = 0;
	else
		{
		QString portStr = this->port->text();
		port = portStr.toInt(&b);
		}
	return new Connection(sql, ppath, pname, host->text(), user->text(), passwd->text(), port);
	}




