/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef EDITABLETABLISTBOX_H
#define EDITABLETABLISTBOX_H

#include <qwidget.h>
#include <ktablistbox.h>
#include "celledit.h"

class EditableTabListBoxColumn : public KTabListBoxColumn
	{
	Q_OBJECT
	public:
		EditableTabListBoxColumn(KTabListBox *, int =0);
	signals:
		void sigPaintCell();
	protected:
		void paintCell(QPainter *, int, const QString &, bool);
	};

class EditableTabListBox : public KTabListBox
	{
  Q_OBJECT
	public:
		EditableTabListBox(QWidget *parent=0, const char *name=0);
		virtual ~EditableTabListBox(void);
		void setEditable(bool);
	signals:
		void cellChanged(int, int, const char *, const char *);
	protected:
		virtual bool validateCellChange(int, int, const char *, const char *);
		virtual KTabListBoxColumn *newKTabListBoxColumn(void);
	private:
		void editCell(int, int);
		void putCellEditor(int, int);
		void updateCellEditor(void);
		void saveCellChange(void);
	private slots:
		void slotSelected(int, int);
		void slotHighlighted(int, int);
		void stopEditCell(bool);
		void slotPaintCell();
	private:
		CellEdit *currentCellEditor;
		int editRow, editCol;
		QString oldValue, newValue;
		bool editing, editable;
	};

#endif











