/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FEBUTTON_H
#define FEBUTTON_H

#include <qpushbutton.h>
#include "fegrid.h"
#include "isqlserver.h"
#include "fewidget.h"

typedef FeWidget<QPushButton> FeButtonInherited;

class FeButton : public FeButtonInherited
	{
	Q_OBJECT
	public:
		enum Function { Cancel, Submit, Help };
		FeButton(QWidget *);
		void setFunction(Function f) { _function = f; }
		Function function(void) { return _function; }
		void setDefault(bool b) { _default = b; }
		bool isDefault(void) { return _default; }
		bool setOptions(QString);
		bool writeDatabase(ISqlServer *, QString);
		void showProperties(void);
	private:
		Function _function;		
		bool _default;
	};

#endif


















