/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "fecheckbox.h"
#include "dlgfepropcheckbox.h"
#include "utils.h"

FeCheckBox::FeCheckBox(QWidget *parent)
	: FeCheckBoxInherited(parent)
	{
	}
	
	
bool FeCheckBox::setOptions(QString str)
	{
	Utils::Option option;
	if(!option.fromString(str))
		return false;
	if(option.getName() == "options")
		{
		setText(option.getParam(0));
		setInitialState(option.getParam(1) == "On");
 		setValues(option.getParam(2), option.getParam(3));
		}
	return true;
	}
	
bool FeCheckBox::writeDatabase(ISqlServer *sql, QString formId)
	{
	if(!sql)
		return false;
	Utils::Option options;
	options.setName("options");
	options.addParam(text());
	options.addParam(initialState() ? "On" : "Off");
	options.addParam(checkedValue());
	options.addParam(uncheckedValue());
	QString extra = Utils::insertQuotes(options.toString());
	QString query(16000);
	query.sprintf("INSERT INTO __KmysqlFields (FormRef, Name, Type, X, Y, Width, Height, Extra) VALUES (%s, '%s', '%s', %d, %d, %d, %d, '%s')",
								(const char *)formId, (const char *)Utils::insertQuotes(name()), "checkbox", x(), y(), width(), height(), (const char *)extra);
	warning("%s", (const char *)query);
  QueryResult res = sql->query(query);
  if(res.type == QueryResult::Error)
  	return false;
  return true;
	}

void FeCheckBox::showProperties(void)
	{
	DlgFePropCheckBox dlg(this, this);
	if(dlg.exec())
		dlg.save();
	}	



























