/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FECHECK_BOX_H
#define FECHECK_BOX_H

#include <qcheckbox.h>
#include "fegrid.h"
#include "isqlserver.h"
#include "fewidget.h"

typedef FeWidget<QCheckBox> FeCheckBoxInherited;

class FeCheckBox : public FeCheckBoxInherited
	{
	Q_OBJECT
	public:
		FeCheckBox(QWidget *);
		bool initialState(void) { return _initialState; }
		void setInitialState(bool b) { _initialState = b; }
		QString checkedValue(void) { return _checkedValue; }
		QString uncheckedValue(void) { return _uncheckedValue; }
		void setValues(QString c, QString u) { _checkedValue = c; _uncheckedValue = u; }
		bool setOptions(QString);
		bool writeDatabase(ISqlServer *, QString);
		void showProperties(void);
	private:
		bool _initialState;
		QString _checkedValue;
		QString _uncheckedValue;
	};

#endif

















