/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "fecombo.h"
#include "dlgdepropcombo.h"
#include "utils.h"

FeCombo::FeCombo(QWidget *parent)
	: FeComboInherited(parent)
	{
	setChoicesOrigin(List);
	}
	
bool FeCombo::setOptions(QString str)
	{
	if(str.isEmpty())
		return true;
	clear();
	Utils::Option option;
	if(!option.fromString(str))
		return false;
	if(option.getName() == "options")
		{
		choices()->clear();
		QString tmp = option.getParam(0);
		if(tmp == "query")
			setChoicesOrigin(Query);
		else if(tmp == "list")
			setChoicesOrigin(List);
		else
			return false;
		setChoicesQuery(option.getParam(1));
		for(unsigned int i = 2; i < option.getParamCount(); i++)
			choices()->append(option.getParam(i));
		}
	else
		return false;
	return true;
	}
	
bool FeCombo::writeDatabase(ISqlServer *sql, QString formId)
	{
	if(!sql)
		return false;
	Utils::Option options;
	options.setName("options");
	if(choicesOrigin() == Query)
		options.addParam("query");
	else if(choicesOrigin() == List)
		options.addParam("list");
	else
		return false;
	options.addParam(choicesQuery());
	for(unsigned int i=0; i<choices()->count(); i++)
		options.addParam(choices()->at(i));
	QString extra = Utils::insertQuotes(options.toString());
	QString query(16000);
	query.sprintf("INSERT INTO __KmysqlFields (FormRef, Name, Type, X, Y, Width, Height, Extra) VALUES (%s, '%s', '%s', %d, %d, %d, %d, '%s')",
								(const char *)formId, (const char *)Utils::insertQuotes(name()), "combo", x(), y(), width(), height(), (const char *)extra);
  QueryResult res = sql->query(query);
  if(res.type == QueryResult::Error)
  	return false;
  return true;
	}

void FeCombo::showProperties()
	{
	DlgDePropCombo dlg(this, this);
	if(dlg.exec())
		dlg.save();
	}	
	














