/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FECOMBO_H
#define FECOMBO_H

#include <qcombobox.h>
#include <qstrlist.h>
#include "fegrid.h"
#include "isqlserver.h"
#include "fewidget.h"

typedef FeWidget<QComboBox> FeComboInherited;

class FeCombo : public FeComboInherited
	{
	Q_OBJECT
	public:
		enum ChoicesOrigin { List, Query };
		FeCombo(QWidget *);
		ChoicesOrigin choicesOrigin(void) { return _choicesOrigin; }
		void setChoicesOrigin(ChoicesOrigin o) { _choicesOrigin = o; }
		QStrList *choices(void) { return &_choices; }
		QString choicesQuery(void) { return _choicesQuery; }
		void setChoicesQuery(QString s) { _choicesQuery = s; }
		bool setOptions(QString);
		bool writeDatabase(ISqlServer *, QString);
		void showProperties(void);
	private:
		ChoicesOrigin _choicesOrigin;		
		QStrList _choices;
		QString _choicesQuery;
	};

#endif













