/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "feedit.h"
#include "dlgfepropedit.h"
#include "utils.h"

FeEdit::FeEdit(QWidget *parent)
	: FeEditInherited(parent)
	{
	setCursor(arrowCursor);
	}

bool FeEdit::setOptions(QString str)
	{
	if(str.isEmpty())
		return true;
	Utils::Option option;
	if(!option.fromString(str))
		return false;
	if(option.getName() == "options")
		setDefaultValue(option.getParam(0));
	return true;
	}	
	
bool FeEdit::writeDatabase(ISqlServer *sql, QString formId)
	{
	if(!sql)
		return false;	
	Utils::Option option;
	option.setName("options");
	option.addParam(defaultValue());
	QString extra = Utils::insertQuotes(option.toString());
	QString query(16000);
	query.sprintf("INSERT INTO __KmysqlFields (FormRef, Name, Type, X, Y, Width, Height, Extra) VALUES (%s, '%s', '%s', %d, %d, %d, %d, '%s')",
								(const char *)formId, (const char *)Utils::insertQuotes(name()), "text", x(), y(), width(), height(), (const char *)extra);
  QueryResult res = sql->query(query);
  if(res.type == QueryResult::Error)
  	return false;
  return true;
	}

void FeEdit::showProperties()
	{
	DlgFePropEdit dlg(this, this);
	if(dlg.exec())
		dlg.save();
	}	


















