/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "feframe.h"
#include "dlgfepropform.h"
#include <qobjectlist.h>

FeFrame::FeFrame(QWidget *parent)
	: FeFrameInherited(parent, true)
	{
	setQuery("");
	setHelp("");
	}

void FeFrame::paintEvent(QPaintEvent *e)
	{
	FeFrameInherited::paintEvent(e);
	QPainter p;
	p.begin(this);
	p.setPen(black);
	if(FeGrid::isVisible())
		{
		for(int x=lineWidth(); x<width()-lineWidth(); x+=FeGrid::step())
			for(int y=lineWidth(); y<height()-lineWidth(); y+=FeGrid::step())
				p.drawPoint(x, y);
		}
	p.end();
	}	

void FeFrame::showProperties(void)
	{
	DlgFePropForm dlg(this, this);
	if(dlg.exec())
		dlg.save();
	}
	
bool FeFrame::nameExists(QString name, QWidget *but)
	{
	if(!children())
		return false;
  QObjectListIt it(*children());
  QObject *obj;
	while((obj=it.current()) != 0)
		{
		++it;
		QWidget *widget = (QWidget *)obj;
		if(widget != but && widget->name() == name)
			return true;
		}
	return false;
	}







