/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FEFRAME_H
#define FEFRAME_H

#include <qframe.h>
#include <qpainter.h>
#include "fegrid.h"
#include "fewidget.h"

typedef FeWidget<QFrame> FeFrameInherited;

class FeFrame : public FeFrameInherited
	{
	public:
		FeFrame(QWidget *parent);
		void setTitle(QString s) { _title = s; }
		QString title(void) { return _title; }
		void setQuery(QString s) { _query = s; }
		QString query(void) { return _query; }
		void setHelp(QString s) { _help = s; }
		QString help(void) { return _help; }
		bool setOptions(QString);
		void showProperties();
		bool nameExists(QString, QWidget * = 0);
	protected:
		void paintEvent(QPaintEvent *);
	private:
		QString _title;
		QString _query;
		QString _help;
	};

#endif
















