/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "fegrid.h"

int FeGrid::_step = 10;
bool FeGrid::_visible = true;
bool FeGrid::_fit = true;

void FeGrid::setStep(int i)
	{
	_step = i;
	}
	
int FeGrid::step(void)
	{
	return _step;
	}

void FeGrid::setVisible(bool b)
	{
	_visible = b;
	}
	
bool FeGrid::isVisible(void)
	{
	return _visible;
	}
	
void FeGrid::setFit(bool b)
	{
	_fit = b;
	}
	
bool FeGrid::isFit(void)
	{
	return _fit;
	}
		
QPoint FeGrid::manage(QPoint p)
	{
	if(!isFit())
		return p;
	else
		return QPoint((p.x()/step())*step(), (p.y()/step())*step());
	}
	
QSize FeGrid::manage(QSize s)
	{
	if(!isFit())
		return s;
	else
		return QSize((s.width()/step())*step(), (s.height()/step())*step());
	}




