/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "felabel.h"
#include "dlgfeproplabel.h"
#include "utils.h"

FeLabel::FeLabel(QWidget *parent)
	: FeLabelInherited(parent)
	{
	}

bool FeLabel::setOptions(QString str)
	{
	Utils::Option option;
	if(!option.fromString(str))
		return false;
	if(option.getName() == "options")
		{
		if(option.getParamCount() != 1)
			{
			warning("incorrect button params count in options");
			return false;
			}
		setText(option.getParam(0));
		}
	else
		{
		warning("unknown button option: '%s'", (const char *)option.getName());
		return false;
		}
	return true;
	}
	
bool FeLabel::writeDatabase(ISqlServer *sql, QString formId)
	{
	if(!sql)
		return false;
	Utils::Option options;
	options.setName("options");
	options.addParam(text());
	QString extra = Utils::insertQuotes(options.toString());
	QString query(16000);
	query.sprintf("INSERT INTO __KmysqlFields (FormRef, Name, Type, X, Y, Width, Height, Extra) VALUES (%s, '%s', '%s', %d, %d, %d, %d, '%s')",
								(const char *)formId, (const char *)Utils::insertQuotes(name()), "label", x(), y(), width(), height(), (const char *)extra);
  QueryResult res = sql->query(query);
  if(res.type == QueryResult::Error)
  	return false;
  return true;
	}
	

void FeLabel::paintEvent(QPaintEvent *e)
	{
	FeLabelInherited::paintEvent(e);
	QPainter p;
	p.begin(this);
	p.setPen(DotLine);
	p.setBrush(NoBrush);
	p.drawRect(0, 0, width(), height());
	p.end();
	}
	
void FeLabel::showProperties(void)
	{
	DlgFePropLabel dlg(this, this);
	if(dlg.exec())
		dlg.save();
	update();
	}	
	



