/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "fewidgetmenu.h"
#include <kapp.h>

FeWidgetMenu::FeWidgetMenu(QWidget *related, bool isFrame)
	: relatedWidget(related)
	{
	insertItem("&Properties", this, SLOT(slotProperties()));
	if(!isFrame)
		{
		QPopupMenu *position = new QPopupMenu();
		position->insertItem(i18n("&Raise"), this, SLOT(slotRaise()));
		position->insertItem(i18n("&Lower"), this, SLOT(slotLower()));	
		insertItem(i18n("P&osition"), position);
		insertItem(i18n("&Delete"), this, SLOT(slotDelete()));
		}
	}

void FeWidgetMenu::slotProperties()
	{
	KApplication::getKApplication()->postEvent(relatedWidget, new EventProperties);
	}
		
void FeWidgetMenu::slotDelete()
	{
	delete relatedWidget;
	delete this;
	}
	
void FeWidgetMenu::slotRaise()
	{
	relatedWidget->raise();
	}
	
void FeWidgetMenu::slotLower()
	{
	relatedWidget->lower();
	}



