/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FORMDIALOG_H
#define FORMDIALOG_H

#include <qdialog.h>
#include <qlist.h>
#include <qlayout.h>
#include <qlineedit.h>
#include <qcombobox.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qcheckbox.h>
#include <kdatepik.h>

#include "isqlserver.h"

class QMyCheckBox : public QCheckBox
	{
	Q_OBJECT
	public:
		QMyCheckBox(QWidget *parent) : QCheckBox(parent) {}
		QString checkedValue, uncheckedValue;
	};
	
class KMyDatePicker : public KDatePicker
	{
	Q_OBJECT
	public:
		KMyDatePicker(QWidget *parent) : KDatePicker(parent), date(QDate::currentDate()) { connect(this, SIGNAL(dateSelected(QDate)), this, SLOT(slotDateSelected(QDate))); }
		QDate selectedDate(void) { return date; }		
	private slots:
		void slotDateSelected(QDate aDate) { date = aDate; warning("%s", (const char *)date.toString()); }
	private:
		QDate date;		
	};

class QMyComboBox : public QComboBox
	{
	Q_OBJECT
	public:
		QMyComboBox(QWidget *parent) : QComboBox(parent) {}
	public:
		QStrList values;
	};
	
class FormDialog : public QDialog
  {
  Q_OBJECT
  public:
    FormDialog(QWidget *);
    int load(ISqlServer *, QString);
    ~FormDialog(void);
    QString makeQuery(void);
  private:
    QString getValue(QString);
    QString widgetValue(QWidget *);
  private slots:
    void slotOk();
    void slotCancel();
    void slotHelp();
  private:
    QString query;
		QString help;
		static const char substChar = '$';
  };

#endif 








