/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef FormEditorView_included
#define FormEditorView_included

#include <ktmainwindow.h>
#include <qmessagebox.h>
#include <kfiledialog.h>
#include <kiconloader.h>
#include <kapp.h>
#include <qframe.h>

#include "dlgfeconfig.h"
#include "isqlserver.h"

#include "view.h"
#include "febutton.h"
#include "felabel.h"
#include "feedit.h"
#include "fecombo.h"
#include "feframe.h"
#include "fecheckbox.h"
#include "fedate.h"


class FormEditorView : public View
  {
  Q_OBJECT
  public:
    FormEditorView(MainWindow *);
    int load(ISqlServer *, QString);
    int save(ISqlServer *);
    void clear(void);
    int valid(void);
    void setEnabled(bool);
  public slots:
  	void formProperties();
  	void formSave();
  	void formCancel();
    void newButton();
    void newLabel();
    void newEdit();
    void newCombo();
    void newCheckBox();
    void newDate();
    void config();
  private:
  	void savePref(void);
  	void loadPref(void);
  	QString newName(void);
  	void initWidgets(void);
  	void initToolBars(void);
  	void initMenus(void);
  	void initConnects(void);
  private:
  	KMenuBar *menu;
    FeFrame *frame;
    int widgetCount;
    int tbIdMain;
    int tbIdItems;
  };

#endif 


































