/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "formutils.h"
#include <qmessagebox.h>
#include <kapp.h>


bool FormUtils::removeFormFromDatabase(ISqlServer *sql, QString name)
	{
	if(!sql)
		return false;
	// Get ref
	QString request = "SELECT Ref FROM __KmysqlForms WHERE Name='"+name+"'";
	QueryResult res = sql->query(request);
	if(res.type == QueryResult::Error)
		return false;	
	QString ref = res.result.at(0);
	// Delete fields
	request = "DELETE FROM __KmysqlFields WHERE FormRef="+ref;
	res = sql->query(request);
	if(res.type == QueryResult::Error)
		return false;	
	// Delete form
	request = "DELETE FROM __KmysqlForms WHERE Name='"+name+"'";
	res = sql->query(request);
	if(res.type == QueryResult::Error)
		return false;				
	return true;
	}
	
bool FormUtils::prepareBaseForForms(ISqlServer *sql, QString base)
	{
	if(!sql)
		return false;
	QueryResult res;
	res = sql->selectBase(base);
	if(res.type == QueryResult::Error)
	   return false;
	res = sql->query("CREATE TABLE __KmysqlForms (Ref INT NOT NULL AUTO_INCREMENT, Name VARCHAR(255) NOT NULL, Query TEXT NOT NULL, Help TEXT NOT NULL, Width INT NOT NULL, Height INT NOT NULL, PRIMARY KEY(Ref))");
	if(res.type == QueryResult::Error)
	   return false;
	res = sql->query("CREATE TABLE __KmysqlFields (Ref INT NOT NULL AUTO_INCREMENT, FormRef INT NOT NULL, Name VARCHAR(255) NOT NULL, Type VARCHAR(63) NOT NULL, X INT NOT NULL, Y INT NOT NULL, Width INT NOT NULL, Height INT NOT NULL, Extra TEXT NOT NULL, PRIMARY KEY(Ref))");
	if(res.type == QueryResult::Error)
	   return false;
	return true;	
	}

bool FormUtils::isBaseInCurrentFormat(ISqlServer *sql, QString base)
	{	
	if(!sql)
		return false;
	QueryResult res;
	res = sql->selectBase(base);
	if(res.type == QueryResult::Error)
	   return false;
	// On regarde si c'tait une table de la version prcdente
	res = sql->query("show fields from __KmysqlForms");
	if(res.result.count() != 6)
		return false;
	return true;
	}	
	
bool FormUtils::updateBaseToCurrentFormat(ISqlServer *sql, QString base)
	{
	if(!sql)
		return false;
	QueryResult res;
	res = sql->selectBase(base);
	if(res.type == QueryResult::Error)
	   return false;
	int r = QMessageBox::critical(0, i18n("Forms"), i18n("Your database contains forms in a deprecated format, and will be updated.\nI'm sorry this will cause existing forms to be lost ;(\nDo you want to continue?"),
																QMessageBox::Yes, QMessageBox::No);
	if(r == QMessageBox::No)
		return false;
	res = sql->query("drop table __KmysqlForms");
	if(res.type == QueryResult::Error)
	   return false;
	sql->query("drop table __KmysqlFields");
	if(res.type == QueryResult::Error)
	   return false;	
	return prepareBaseForForms(sql, base);
	}

bool FormUtils::isBasePreparedForForms(ISqlServer *sql, QString base)
	{
	if(!sql)
		return false;
	QueryResult res;	
	res = sql->selectBase(base);
	if(res.type == QueryResult::Error)
	   return false;
	// On vrifie que la table __KmysqlForms existe
	res = sql->query("show tables like \"__KmysqlForms\"");
	if(res.type == QueryResult::Error)
	   return false;
	if(res.result.count() == 0)
		return false;
	return true;
	}


