/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "history.h"
#include <kapp.h>

History::History(QWidget *parent, const char *name)
	: QListBox(parent, name)
	{
	popup = new QPopupMenu();
	popup->insertItem(i18n("&Edit"), this, SLOT(slotEdit()));
	popup->insertItem(i18n("&Execute"), this, SLOT(slotExecute()));
	popup->insertSeparator();
	popup->insertItem(i18n("&Clear"), this, SLOT(slotClear()));
	}
	
	
void History::slotEdit()
	{
	if(currentItem() != -1)
		emit edit(currentItem());
	}
	
void History::slotExecute()
	{
	if(currentItem() != -1)
		emit execute(currentItem());
	}

void History::slotClear()
	{
	setAutoUpdate(false);
	clear();
	setAutoUpdate(true);
	repaint();
	}

void History::mousePressEvent(QMouseEvent *e)
	{
	if(currentItem() == -1)
		return;
	QListBox::mousePressEvent(e);
	if(e->button() == RightButton)
    popup->popup(mapToGlobal(e->pos()));
 	} 	




