/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ISQLSERVER_H
#define ISQLSERVER_H

#include "iobject.h"
#include "queryresult.h"

interface ISqlServer : IObject
	{
	virtual QueryResult connect(QString, QString, QString, int) = 0;
  virtual void close(void) = 0;
  virtual QueryResult selectBase(QString) = 0;
  virtual QueryResult getBases(void) = 0;
  virtual QueryResult getTables(QString, QString = 0) = 0;
  virtual QueryResult getColumns(QString, QString) = 0;
  virtual QueryResult query(QString) = 0;
  virtual QueryResult createBase(QString) = 0;
  virtual QueryResult dropBase(QString) = 0;
  virtual QueryResult shutdown(void) = 0;
  virtual QueryResult reload(void) = 0;
  virtual QString serverInfo(void) = 0;
  virtual bool isConnected(void) = 0;
	};

#define UIID_SQLSERVER 0xa156cd01

#endif // ISQLSERVER_H



