/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qapp.h>
#include <qmenubar.h>
#include <qpopmenu.h>
#include <qmsgbox.h>
#include <qcombo.h>
#include <qstrlist.h>
#include <qlist.h>
#include <qstring.h>
#include <qprinter.h>

#include <kapp.h>
#include <kcombo.h>
#include <kmsgbox.h>
#include <kpopmenu.h>
#include <kmenubar.h>
#include <kmsgbox.h>
#include <kfiledialog.h>
#include <kstatusbar.h>
#include <ktmainwindow.h>
#include <kiconloader.h>
#include <kmsgbox.h>

#include "mainview.h"
#include "formeditorview.h"
#include "tableeditorview.h"


class MainWindow : public KTMainWindow
  {
    Q_OBJECT
  public:
  	enum Mode { ModeNormal, ModeFormEditor, ModeTableEditor };
    MainWindow(const char * =0);
    ~MainWindow(void);
    void statusMessage(QString, int =0);
   	void setMode(Mode);
   	MainView *mainView(void) { return _mainView; }
   	FormEditorView *feView(void) { return _feView; }
   	TableEditorView *teView(void) { return _teView; }
  signals:
  	void quit();
  protected:
    virtual void closeEvent(QCloseEvent *);
  private slots:
		void slotQuit();
	private:
		void saveGeometry(void);
		void loadGeometry(void);
  private:  	
	  MainView *_mainView;
  	FormEditorView *_feView;
  	TableEditorView *_teView;
    KStatusBar *status;
  };
































































