/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PLUGINMANAGER_H
#define PLUGINMANAGER_H

#include <kconfig.h>
#include "plugin.h"
#include "isqlserver.h"
#include <qstring.h>
#include <qstrlist.h>

const int MAX_PLUGINS = 10;

class PluginManager
	{
	public:
		PluginManager(void);
		~PluginManager(void);
		int registerPlugin(QString path); // Returns the id to be used for future references to the plugin. A negative value means an error
		int unregisterPlugin(int id);
		ISqlServer *createInstance(int id);
		const char *getPluginName(int id);
		const char *getPluginInfo(int id);
		const char *getPluginPath(int id);
		const char *getErrorString() { return errorString; }
		int getPluginByName(QString);
		int getPluginByPath(QString);
		QStrList *getPluginNames(void);
		void savePref(KConfig *);		
		void readPref(KConfig *);
		int count(void);
		static PluginManager *getInstance(void);
		bool autodetectPlugins();
	private:
		Plugin *plugins[MAX_PLUGINS];
		static PluginManager *instance;
		QString errorString;
	};

#endif


















