/***************************************************************************
                          queryanalizer.cpp  -  description
                             -------------------
    begin                : Mon Dec 13 1999
    copyright            : (C) 1999 by Tiberiu Craciun
    email                : tiberiu@akela.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "queryanalizer.h"
#include "dbwidget.h"
#include <iostream.h>
#include <qregexp.h>

QueryAnalizer::QueryAnalizer(KNewPanner *qaview,QObject* parent,char* name): QObject(parent,name) {
  mainPanner = qaview;
  edit = new QueryEdit(mainPanner);
  rez = new QueryEdit(mainPanner);
  qaview->activate(edit,rez);
  rez->normalHighlight();
  connect(edit,SIGNAL(sigCtrl_e()),this,SLOT(slotExecute()));
}

QueryAnalizer::~QueryAnalizer(){
}


/**  */
void QueryAnalizer::slotExecute(){
	QString query;
	query=edit->markedText();
	if(query.isEmpty() || query.isNull()) {
		query=edit->text();
	}
	int index=0, ind, len=query.length();
	QString q;
	while(index<len){
	        ind=query.find(";",index);
	        if(ind==-1){
	        	ind=len;
	        }
	        q=query.mid(index,ind-index+1);
	        index=ind+1;
	        q.replace(QRegExp("\n"),"");
	        q.stripWhiteSpace();
//	        cerr << ">" << q << "<" << endl;
		if(!(q.isEmpty() || q.isNull())) {
			rez->loadString(db->executeQuery(q));
//			rez->loadString("\n");
			rez->repaint();
		}
	}
}


void QueryAnalizer::slotClear(){
	rez->loadString("",0);
	rez->repaint();
}


