/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TABLEEDITORVIEW_H
#define TABLEEDITORVIEW_H

#include <qwidget.h>
#include <qlayout.h>
#include <kapp.h>
#include <kiconloader.h>
#include <kmenubar.h>
#include <ktoolbar.h>
#include "tabview.h"
#include "view.h"
#include "isqlserver.h"

class TableEditorView : public View
	{
  Q_OBJECT
	public:
		TableEditorView(MainWindow *);
		~TableEditorView(void);
		void setEnabled(bool);
		void edit(ISqlServer *, QString);
	private:
		void initWidgets(void);
  	void initToolBars(void);
  	void initMenus(void);
  	void initConnects(void);
  	bool getKeys(QStrList &);
 	private slots:
 		void slotCellChanged(int, int, const char *, const char *);
	private:
		KMenuBar *menu;
		TabView *tab;	
		int tbId;
		ISqlServer *sql;
		QString tableName;
	};

#endif














