#include <kiconloader.h>
#include "tabviewgroup.h"

TabViewGroup::TabViewGroup(QWidget *parent)
	: STabCtl(parent)
	{
	KIconLoader *iconLoader = KApplication::getKApplication()->getIconLoader();
  tablePix = iconLoader->loadIcon("table.xpm");
  showTabIcon(true);/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


	newView();
	}
	
TabViewGroup::~TabViewGroup(void)
	{
	}
	
	
bool TabViewGroup::newView(QString viewName)
	{
	if(viewName.isEmpty())
		viewName = i18n("New view");
	TabView *view = new TabView(this, viewName);
	if(!view)
		return false;
	insertPage(view, viewName);	
	setPixmap(view, tablePix);
	return true;
	}

bool TabViewGroup::deleteCurrentView(void)
	{
	if(pageCount() <= 1)
		return false;
	removePage(currentView());
	return true;
	}	
		

TabView *TabViewGroup::currentView(void)
	{
	return (TabView *)visiblePage();
	}
	

bool TabViewGroup::exists(QString viewName)
	{
	return false;
	}


bool TabViewGroup::windowizeCurrentView(void)
	{
	return windowizeView(currentView());
	}
	
bool TabViewGroup::windowizeView(TabView *view)
	{
	if(pageCount() <= 1)
		newView();
	removePage(view);
	(void)new TabViewWindow(view);
	return true;
	}
	














