/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "tabviewwindow.h"

TabViewWindow::TabViewWindow(TabView *tabView)
	:	QWidget(0), tabView(tabView)
	{
	KIconLoader *iconLoader = KApplication::getKApplication()->getIconLoader();
	tabView->recreate(this, 0, QPoint(0, 0));
	tabView->resize(width(), height());
	setCaption(tabView->name());
  setIcon(iconLoader->loadIcon(QString("table.xpm")));
	show();	
	}
	
TabViewWindow::~TabViewWindow(void)
	{
	}

void TabViewWindow::closeEvent(QCloseEvent *e)
	{
	e->accept();
	delete tabView;
	delete this;
	}
	
void TabViewWindow::resizeEvent(QResizeEvent *e)
	{
	QWidget::resizeEvent(e);
	tabView->resize(width(), height());
	}




