/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qstring.h>
#include <qlist.h>

class TaggedText
	{
	public:
		TaggedText(void);
		void setPathSeparator(char);
		char pathSeparator(void) const;
		QString toString(void) const;
		bool fromString(const QString &);
		QString get(const QString &) const;
		bool set(const QString &, const QString &);
		QString operator[](const QString &) const;
		QString &operator[](const QString &);
		void clear(void);
		int errorCode(void) const;
		QString errorMessage(void) const;
	private:
		class Node
			{
			public:
				Node(const QString &);
				QString name(void) const;
				QString value(void) const;
				QString quotedValue(void) const;
				QString &valueRef(void);
				Node *child(const QString &) const;
				void setValue(const QString &);
				void addChild(Node *);
				QString toString(bool = true) const;
				void clear(void);
			private:
				QString _name;
				QString _value;
				QList<Node> _children;
			};
	private:
		QString firstTagOfPath(const QString &) const;
		QString restOfPath(const QString &) const;
		QString addToPath(const QString &, const QString &) const;
		QString lastFromPath(const QString &) const;
		QString removeLastFromPath(const QString &) const;
		bool set(const QString &, const QString &, Node *);
		QString get(const QString &, const Node *) const;
		QString &getValueRef(const QString &, Node *);
	private:
		Node root;
		char separator;
		int error;
		QString message;
	};

