/***************************************************************************
    copyright            : (C) 1999 by Frederik Bilhaut
    email                : bilhaut_f@mail.cpod.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef UTILS_H
#define UTILS_H

#include <qstring.h>
#include <qstrlist.h>

class Utils
	{
	public: // Functions
		static QString subStringAt(QString, char, unsigned int);
		static QString insertQuotes(QString);
		static void splitQueries(QString, QStrList &);
		
	public: // Classes
	
		class Option
			{
			public:
				void clear(void);
				bool fromString(QString);
				QString toString(void);
				QString getName(void);
				QString getParam(unsigned int);
				unsigned int getParamCount(void);
				void setName(QString);
				void addParam(QString);
			private:
				QString insertEscapeChars(QString);
			private:
				QString name;
				QStrList params;
			};
		
	};
	


#endif






