/***************************************************************************
                          kphpdev.cpp  -  description
                             -------------------
    begin                : Fri Nov 26 21:19:03 EET 1999
    copyright            : (C) 1999 by Tiberiu Craciun
    email                : tiberiu@akela.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
//#include <kapp.h>

#include <kiconloader.h>

#include "kphpdev.h"
#include "crealfileview.h"
#include "ctabctl.h"
#include "resource.h"
#include <kiconloader.h>
#include <kmsgbox.h>
#include "ctcpclient.h"
#include "cserverconnect.h"

#include "kwrite/highlight.h"
#include "kwrite/kwdoc.h"
#include "kwrite/kwview.h"
#include "stabctl/stabctl.h"
#include "copenfile.h"

//KPHPDev::KPHPDev(QWidget*parent,const char* name):QWidget(parent,name){
KPHPDev::KPHPDev(QWidget*parent,const char* name){
	initStatusBar();
	initToolBar();
	initMenuBar();
	files=new CEdit(this);
	view=new KNewPanner(this,"view",KNewPanner::Vertical,KNewPanner::Percent,40);
	tabl=new CTabCtl(view);
	tabr=new CTabCtl(view);
	rfv=new CRealFileView(tabl, "Files");
//	rfv=new CRealFileView(this, "Files");
//	rfv->setMinimumSize(200,300);
	rfv->refresh();
	tabl->addTab(rfv,"Project");
	opened=new CFiles(tabl);
	tabl->addTab(opened,"Working");
	dbtree=new ServerTree(tabl);	
	tabl->addTab(dbtree,"Data");

	stab=new STabCtl(tabr);
//	qa->setMinimumSize(100,100);
//cerr << "aici 0" << endl;
	dbview=new DBWidget(dbtree,tabr);		
//	qa=new QueryAnalizer(tabl);
//cerr << "aici 1" << endl;
//	qa->db=dbview;
//  hl=new HlManager();
//  kwd=new KWriteDoc(hl,"");
//  kw=new KWrite(kwd,stab,"");
  tabr->addTab(stab,"Sources");
  tabr->addTab(dbview,"DataBase");
//  tabl->addTab(qa,"Query analizer");

  KNewPanner *qaview=new KNewPanner(tabr,"view",KNewPanner::Horizontal,KNewPanner::Percent,60);
//  STabCtl *qatabl=new STabCtl(qaview);
//  STabCtl  *qatabr=new STabCtl(qaview);
  qa=new QueryAnalizer(qaview,qaview);
  qa->db=dbview;
  tabr->addTab(qaview,"Query Analizer");
//  cerr << "aici 2"<<endl;
//  tabr->addTab(new KNewPanner(tabr,"view1",KNewPanner::Vertical,KNewPanner::Percent,40),"test");
//  stab->insertPage(kw,"",1);
  view->activate(tabl,tabr);
//	view->setGeometry(0,0,800,600);
	setView(view);
//	kw->client=rfv->client;
	connect(rfv,SIGNAL(fileSelected(QString)),this,SLOT(slotFileOpen(QString)));
	dsc=new CServerConnect(rfv,this);
	dsc->hide();
	files->setTabCtl(stab);
	files->setFilesView(opened);
	opened->refresh();
	rfv->opened=opened;
	
    	slotViewToolBar();
    	slotViewStatusBar();

	connect(opened,SIGNAL(fileSelected(QString)),this,SLOT(slotFileOpen(QString)));
	
	connect(rfv,SIGNAL(saveFile(QString)),this,SLOT(slotFileSaveAs(QString)));
	connect(rfv,SIGNAL(closeFile(QString)),this,SLOT(slotFileCloseAs(QString)));
	connect(opened,SIGNAL(saveFile(QString)),this,SLOT(slotFileSaveAs(QString)));
	connect(opened,SIGNAL(scloseFile(QString)),this,SLOT(slotFileCloseAs(QString)));
	
	connect(tabr,SIGNAL(tabSelected(int)),this,SLOT(slotTabRightChanged(int)));
	tabr->setCurrentTab(0);
	connect(tabl,SIGNAL(tabSelected(int)),this,SLOT(slotTabLeftChanged(int)));
	tabl->setCurrentTab(0);
	connect(files,SIGNAL(sigNewPos(int,int,int)),this,SLOT(slotStatusBarPosition(int,int,int)));
}
KPHPDev::~KPHPDev(){
	opened->slotCloseAll();
}


void KPHPDev::initMenuBar()
{

  ///////////////////////////////////////////////////////////////////
  // MENUBAR

  KIconLoader *il=KApplication::getKApplication()->getIconLoader();

  recent_files_menu = new QPopupMenu();
  connect( recent_files_menu, SIGNAL(activated(int)), SLOT(slotFileOpenRecent(int)) );

  ///////////////////////////////////////////////////////////////////
  // menuBar entry file_menu
  file_menu = new QPopupMenu();
//  file_menu->insertItem(kapp->getMiniIcon(), i18n("New &Window"), ID_FILE_NEW_WINDOW );
//  file_menu->insertSeparator();
  file_menu->insertItem(il->loadIcon("cserver.xpm"), i18n("&Open project"), ID_FILE_NEW );
//  file_menu->insertItem(Icon("fileopen.xpm"), i18n("&Open..."), ID_FILE_OPEN );
//  file_menu->insertItem(i18n("Open &recent"), recent_files_menu, ID_FILE_OPEN_RECENT );

  file_menu->insertSeparator();
  file_menu->insertItem(Icon("filefloppy.xpm") ,i18n("&Save"), ID_FILE_SAVE );
 // file_menu->insertItem(i18n("Save &As..."), ID_FILE_SAVE_AS );
  file_menu->insertItem(i18n("&Close"), ID_FILE_CLOSE );
  file_menu->insertItem(i18n("&Close all"), ID_FILE_CLOSE_ALL );
//  file_menu->insertItem(Icon("windowize.xpm"), i18n("&Window-ize"), this, SLOT(slotSViewWindowize()));
  file_menu->insertSeparator();
  file_menu->insertItem(Icon("fileprint.xpm"), i18n("&Print..."), ID_FILE_PRINT );
  file_menu->insertSeparator();
  file_menu->insertItem(i18n("E&xit"), ID_FILE_QUIT );
	
  ///////////////////////////////////////////////////////////////////
  // menuBar entry edit_menu
  edit_menu = new QPopupMenu();
  edit_menu->insertItem(Icon("editcut.xpm"), i18n("Cu&t"), ID_EDIT_CUT );
  edit_menu->insertItem(Icon("editcopy.xpm"), i18n("&Copy"), ID_EDIT_COPY );
  edit_menu->insertItem(Icon("editpaste.xpm"), i18n("&Paste"), ID_EDIT_PASTE );

  ///////////////////////////////////////////////////////////////////
  // menuBar entry view_menu
  view_menu = new QPopupMenu();
  view_menu->setCheckable(true);
  view_menu->insertItem(i18n("&Toolbar"), ID_VIEW_TOOLBAR);
  view_menu->insertItem(i18n("&Statusbar"), ID_VIEW_STATUSBAR );

  QPopupMenu *options_menu = new QPopupMenu();
  options_menu->insertItem(Icon("cserver.xpm"), i18n("&Add server"), this, SLOT(slotAddServer()));
  options_menu->insertItem(Icon("plugin.xpm"), i18n("&Plugins..."), this, SLOT(slotModules()));
  options_menu->insertSeparator();
  options_menu->insertItem(Icon("reload.xpm"), i18n("&Clear"), this, SLOT(slotClear()));
  options_menu->insertItem(i18n("&Fit columns"), this, SLOT(slotFitAll()));
  options_menu->insertSeparator();
  options_menu->insertItem(Icon("filenew.xpm"), i18n("&New view"), this, SLOT(slotViewNew()));
  options_menu->insertItem(Icon("delete.xpm"), i18n("&Remove"), this, SLOT(slotViewRemove()));
  options_menu->insertItem(Icon("windowize.xpm"), i18n("&Window-ize"), this, SLOT(slotViewWindowize()));
  options_menu->insertSeparator();
  options_menu->insertItem(Icon("html.xpm"), i18n("&HTML export"), this, SLOT(slotViewHtmlExport()));
  options_menu->insertItem(Icon("fileprint.xpm"), i18n("&Print..."), this, SLOT(slotPrint()));
  options_menu->insertSeparator();
  options_menu->insertItem(i18n("&Execute query... CTRL - E"), this, SLOT(slotExecute()));
  options_menu->insertItem(i18n("&Clear rezult window..."), this, SLOT(slotClearRez()));
//  options_menu->insertItem(iconLoader->loadIcon("configure.xpm"), i18n("S&ettings..."), this, SLOT(slotPref()));
//  options_menu->insertSeparator();
//  options_menu->insertItem(i18n("Editor &options..."), kw, SLOT(optDlg()));
//  options_menu->insertItem(i18n("Editor &colors..."), kw, SLOT(colDlg()));
//  options_menu->insertItem(i18n("Editor &defaults..."), kw, SLOT(hlDef()));
//  options_menu->insertItem(i18n("Syntax highlighting..."), kw, SLOT(hlDlg()));
//  options_menu->insertSeparator();
//  options_menu->insertItem(i18n("&Save settings"), this, SLOT(slotSavePref()));

  ///////////////////////////////////////////////////////////////////
  // menuBar entry help_menu
  QString about = i18n("This is K PHP Developement version ");
  about += QString(VERSION) + "\n";
 	about += i18n("An integrated WEB development for KDE.");
	about += "\n\nTiberiu Craciun\ntiberiu@akela.ro\nhttp://tiberiu.akela.ro/kphpdev";

  help_menu = new QPopupMenu();
  help_menu = kapp->getHelpMenu(true, about );

  ///////////////////////////////////////////////////////////////////
  // MENUBAR CONFIGURATION
  // insert your popup menus with the according menubar entries in the order
  // they will appear later from left to right
  menuBar()->insertItem(i18n("&File"), file_menu);
  menuBar()->insertItem(i18n("&Edit"), edit_menu);
  menuBar()->insertItem(i18n("&View"), view_menu);
  menuBar()->insertItem(i18n("&DataBase"), options_menu);

  menuBar()->insertSeparator();
  menuBar()->insertItem(i18n("&Help"), help_menu);

  ///////////////////////////////////////////////////////////////////
  // CONNECT THE MENU SLOTS WITH SIGNALS
  // for execution slots and statusbar messages

  connect(file_menu,SIGNAL(activated(int)),SLOT(commandCallback(int)));
  connect(file_menu,SIGNAL(highlighted(int)),SLOT(statusCallback(int)));

  connect(edit_menu,SIGNAL(activated(int)),SLOT(commandCallback(int)));
  connect(edit_menu,SIGNAL(highlighted(int)),SLOT(statusCallback(int)));

  connect(view_menu,SIGNAL(activated(int)),SLOT(commandCallback(int)));
  connect(view_menu,SIGNAL(highlighted(int)),SLOT(statusCallback(int)));

 // connect(options_menu,SIGNAL(activated(int)),SLOT(commandCallback(int)));
 // connect(options_menu,SIGNAL(highlighted(int)),SLOT(statusCallback(int)));

}

void KPHPDev::initToolBar()
{
  KIconLoader *il=KApplication::getKApplication()->getIconLoader();

  ///////////////////////////////////////////////////////////////////
  // TOOLBAR
  toolBar()->insertButton(il->loadIcon("cserver.xpm"), ID_FILE_NEW, true, i18n("Open project") );
//  toolBar()->insertButton(Icon("fileopen.xpm"), ID_FILE_OPEN, true, i18n("Open File") );
  toolBar()->insertButton(Icon("filefloppy.xpm"), ID_FILE_SAVE, true, i18n("Save File") );
  toolBar()->insertButton(Icon("fileprint.xpm"), ID_FILE_PRINT, true, i18n("Print") );
  toolBar()->insertSeparator();
  toolBar()->insertButton(Icon("editcut.xpm"), ID_EDIT_CUT, true, i18n("Cut") );
  toolBar()->insertButton(Icon("editcopy.xpm"), ID_EDIT_COPY, true, i18n("Copy") );
  toolBar()->insertButton(Icon("editpaste.xpm"), ID_EDIT_PASTE, true, i18n("Paste") );
  toolBar()->insertSeparator();
  toolBar()->insertButton(Icon("help.xpm"), ID_HELP_CONTENTS, SIGNAL(clicked() ),
  				kapp, SLOT( appHelpActivated() ), true,i18n("Help"));

  ///////////////////////////////////////////////////////////////////
  // INSERT YOUR APPLICATION SPECIFIC TOOLBARS HERE WITH toolBar(n)


  ///////////////////////////////////////////////////////////////////
  // CONNECT THE TOOLBAR SLOTS WITH SIGNALS - add new created toolbars by their according number
	// connect for invoking the slot actions
  connect(toolBar(), SIGNAL(clicked(int)), SLOT(commandCallback(int)));
	// connect for the status help on holing icons pressed with the mouse button
  connect(toolBar(), SIGNAL(pressed(int)), SLOT(statusCallback(int)));

}


void KPHPDev::initStatusBar()
{
  ///////////////////////////////////////////////////////////////////
  // STATUSBAR
	// TODO: add your own items you need for displaying current application status.
  statusBar()->insertItem(i18n("                                 "), ID_STATUS_POS );
  statusBar()->setInsertOrder( KStatusBar::RightToLeft);
  statusBar()->insertItem(i18n("Ready."), ID_STATUS_MSG );
}

/////////////////////////////////////////////////////////////////////
// SLOT IMPLEMENTATION
/////////////////////////////////////////////////////////////////////

void KPHPDev::slotFileNewWindow()
{
  slotStatusMsg(i18n("Opening a new Application window..."));
	
	KPHPDev* new_window= new KPHPDev();
	new_window->show();
	
  slotStatusMsg(i18n("Ready."));
}

void KPHPDev::slotFileNew()
{
  slotStatusMsg(i18n("Connect to a server..."));
/*	
	if(!doc->saveModified())
		return;
	
	doc->newDocument();		
*/
	
//	QWidget *n;
//	n=new QWidget(tabr);
//	tabr->addTab(n,"new");

//  QString caption=kapp->getCaption();	
//  setCaption(caption+": "/*+doc->getTitle()*/);

//	CServerConnect dsc(rfv,this);
  if(rfv->client){
  if(KMsgBox::yesNo(0, i18n("Warning"), "You have to close all files before opening a new project", KMsgBox::EXCLAMATION) != 2){
   	opened->slotCloseAll();
   	int i=dsc->exec();
	if(i!=0) {
		slotStatusMsg(i18n("Download project structure..."));
		rfv->refresh();
	}
//		kw->client=rfv->client;
		files->changeClient(rfv->client);
  }
  } else {
   	opened->slotCloseAll();
   	int i=dsc->exec();
	if(i!=0) {
		slotStatusMsg(i18n("Download project structure..."));
		rfv->refresh();
	}
//		kw->client=rfv->client;
		files->changeClient(rfv->client);
  }
  slotStatusMsg(i18n("Ready."));
}

void KPHPDev::slotFileOpen(QString file)
{
  slotStatusMsg(i18n("Opening file..."));
	
/*	if(!doc->saveModified())
		return;
	
	QString fileToOpen=KFileDialog::getOpenFileName(QDir::homeDirPath(), "", this, i18n("Open File..."));
	if(!fileToOpen.isEmpty()){
		doc->openDocument(fileToOpen);
    QString caption=kapp->getCaption();	
    setCaption(caption+": "+doc->getTitle());
		addRecentFile(fileToOpen);
	}
  */

		
//	QWidget *n;
//	n=new QWidget(tabr);
//	tabr->addTab(n,file);

	QString msg;
	int ck=checkFile(rfv->client,file);
	int lf;
        if(!opened->existFile(file)){
//	cerr << ck << endl;
	if(ck!=2) {
	        COpenFile of;
	        ck=of.exec();
		if(ck==1){
			lf=lockFile(rfv->client,file);
			//ck=lf;
		}
			
	} else {
		if(ck==2) {
		        //COpenFile of;
	        	//ck=of.exec();
			if(KMsgBox::yesNo(0, i18n("Open file"), "This file is opened by other user ! Open for read only ?", KMsgBox::EXCLAMATION) == 2)
			{ck=0;} else {ck=2;}
		}
	}
        if(ck!=0){
		files->addFile(file,ck);
	}
	} else {
		files->addFile(file,ck);
	}
//	kw->loadTCP(file);
	
//  if(KMsgBox::yesNo(0, i18n("Warning"), msg, KMsgBox::EXCLAMATION) == 2)
//{}
	
	

  slotStatusMsg(i18n("Ready."));
}

void KPHPDev::slotFileOpenRecent(int id_)
{
  slotStatusMsg(i18n("Opening file..."));
	
/*	if(!doc->saveModified())
		return;

  doc->openDocument(recent_files.at(id_));*/
  QString caption=kapp->getCaption();	
	QWidget *n;
	n=new QWidget(this);
	tabr->addTab(n,"new");
  setCaption(caption+": "/*+doc->getTitle()*/);

  slotStatusMsg(i18n("Ready."));
}

void KPHPDev::slotFileSave()
{
  slotStatusMsg(i18n("Saving file..."));
	
/*	doc->saveDocument(doc->getPathName()+doc->getTitle());*/

//	kw->writeFileToTCP();
	files->saveFile();

  slotStatusMsg(i18n("Ready."));
}

void KPHPDev::slotFileSaveAs(QString file)
{
  slotStatusMsg(i18n("Saving file..."));

//	QString newName=KFileDialog::getSaveFileName(QDir::currentDirPath(), "", this, i18n("Save As..."));
/*	if(!newName.isEmpty()){
		QFileInfo saveAsInfo(newName);
		doc->title(saveAsInfo.fileName());
		doc->pathName(saveAsInfo.absFilePath());
		doc->saveDocument(newName);
		addRecentFile(newName);
    QString caption=kapp->getCaption();	
    setCaption(caption+": "+doc->getTitle());
	}
  */
	files->saveFile(file);
  slotStatusMsg(i18n("Ready."));
}

void KPHPDev::slotFileClose()
{
  slotStatusMsg(i18n("Closing file..."));
	opened->closeFile(files->closeFile());
//	close();
  slotStatusMsg(i18n("Ready."));
}

void KPHPDev::slotFileCloseAs(QString file)
{
  slotStatusMsg(i18n("Closing file..."));
	opened->closeFile(files->closeFile(file));
//	close();
  slotStatusMsg(i18n("Ready."));
}

void KPHPDev::slotFilePrint()
{
  slotStatusMsg(i18n("Printing..."));

  QPrinter printer;
  if (printer.setup(this)){
//			view->print(&printer);
		files->print(&printer);
	}

  slotStatusMsg(i18n("Ready."));
}

void KPHPDev::slotFileQuit()
{
//	saveOptions();
	// close the first window, the list makes the next one the first again.
	// This ensures that queryClose() is called on each window to ask for closing
	KTMainWindow* w;
	opened->slotCloseAll();
	if(memberList){
		for(w=memberList->first(); w; w=memberList->first()){
			// only close the window if the closeEvent is accepted. If the user presses Cancel on the saveModified() dialog,
			// the window and the application stay open.
			if(!w->close())
				break;
		}
	}	
}

void KPHPDev::slotFileCloseAll()
{
//	saveOptions();
	// close the first window, the list makes the next one the first again.
	// This ensures that queryClose() is called on each window to ask for closing
	opened->slotCloseAll();
}


void KPHPDev::slotEditCut()
{
  slotStatusMsg(i18n("Cutting selection..."));
	files->cut();
  slotStatusMsg(i18n("Ready."));
}

void KPHPDev::slotEditCopy()
{
  slotStatusMsg(i18n("Copying selection to Clipboard..."));
	files->copy();
  slotStatusMsg(i18n("Ready."));
}

void KPHPDev::slotEditPaste()
{
  slotStatusMsg(i18n("Inserting Clipboard contents..."));
	files->paste();
  slotStatusMsg(i18n("Ready."));
}

void KPHPDev::slotViewToolBar()
{
  ///////////////////////////////////////////////////////////////////
  // turn Toolbar on or off
	if( view_menu->isItemChecked(ID_VIEW_TOOLBAR))
	  view_menu->setItemChecked(ID_VIEW_TOOLBAR, false);
	else
		view_menu->setItemChecked(ID_VIEW_TOOLBAR, true);
		
  enableToolBar();

  slotStatusMsg(i18n("Ready."));
}

void KPHPDev::slotViewStatusBar()
{
  ///////////////////////////////////////////////////////////////////
  //turn Statusbar on or off
	if( view_menu->isItemChecked(ID_VIEW_STATUSBAR))
	  view_menu->setItemChecked(ID_VIEW_STATUSBAR, false);
	else
		view_menu->setItemChecked(ID_VIEW_STATUSBAR, true);

  enableStatusBar();

  slotStatusMsg(i18n("Ready."));
}


void KPHPDev::statusCallback(int id_){
  switch (id_){
    case ID_FILE_NEW_WINDOW:
    	slotStatusHelpMsg(i18n("Opens a new application window"));
    	break;
    case ID_FILE_NEW:
 	  	slotStatusHelpMsg(i18n("Creates a new document"));
 	  	break;
    case ID_FILE_OPEN:
 	  	slotStatusHelpMsg(i18n("Opens an existing document"));
 	  	break;
    case ID_FILE_OPEN_RECENT:
 	  	slotStatusHelpMsg(i18n("Opens a recently used file"));
 	  	break;
    case ID_FILE_SAVE:
 	  	slotStatusHelpMsg(i18n("Save the actual document"));
 	  	break;
    case ID_FILE_SAVE_AS:
 	  	slotStatusHelpMsg(i18n("Save the document as..."));
 	  	break;
    case ID_FILE_CLOSE:
    	slotStatusHelpMsg(i18n("Closes the actual file"));
    	break;
    case ID_FILE_PRINT:
    	slotStatusHelpMsg(i18n("Prints the current document"));
    	break;
    case ID_FILE_QUIT:{
    	QString caption=kapp->getCaption();
    	slotStatusHelpMsg(i18n("Exits "+ caption));
    	break;
    }
    case ID_EDIT_CUT:
    	slotStatusHelpMsg(i18n("Cuts the selected section and puts it to the clipboard"));
    	break;
    case ID_EDIT_COPY:
    	slotStatusHelpMsg(i18n("Copys the selected section to the clipboard"));
    	break;
    case ID_EDIT_PASTE:
    	slotStatusHelpMsg(i18n("Pastes the clipboard contents to actual position"));
    	break;

    case ID_VIEW_TOOLBAR:
    	slotStatusHelpMsg(i18n("Enables / disables the actual Toolbar"));
    	break;
    case ID_VIEW_STATUSBAR:
    	slotStatusHelpMsg(i18n("Enables / disables the actual Statusbar"));
    	break;
		default:
			break;
  }
}

void KPHPDev::slotStatusHelpMsg(const char *text)
{
  ///////////////////////////////////////////////////////////////////
  // change status message of whole statusbar temporary (text, msec)
  statusBar()->message(text, 2000);
}


void KPHPDev::slotStatusMsg(const char *text)
{
  ///////////////////////////////////////////////////////////////////
  // change status message permanently
  statusBar()->clear();
  statusBar()->changeItem(text, ID_STATUS_MSG );
}


void KPHPDev::commandCallback(int id_){
  switch (id_){
    case ID_FILE_NEW_WINDOW:
    	slotFileNewWindow();
    	break;
    case ID_FILE_NEW:
    	slotFileNew();
    	break;
    case ID_FILE_OPEN:
    	slotFileOpen("");
    	break;
    case ID_FILE_SAVE:
    	slotFileSave();
    	break;
    case ID_FILE_SAVE_AS:
    	slotFileSaveAs("");
    	break;
    case ID_FILE_CLOSE:
    	slotFileClose();
    	break;
    case ID_FILE_CLOSE_ALL:
    	slotFileCloseAll();
    	break;
    case ID_FILE_PRINT:
    	slotFilePrint();
    	break;
    case ID_FILE_QUIT:
    	slotFileQuit();
    	break;

    case ID_EDIT_CUT:
    	slotEditCut();
    	break;
    case ID_EDIT_COPY:
    	slotEditCopy();
    	break;
    case ID_EDIT_PASTE:
    	slotEditPaste();
    	break;

    case ID_VIEW_TOOLBAR:
    	slotViewToolBar();
    	break;
    case ID_VIEW_STATUSBAR:
    	slotViewStatusBar();
    	break;
    default:
    	break;
  }
}


/**  */
void KPHPDev::slotAddServer(){
	   tabr->setCurrentTab(1);
	   tabl->setCurrentTab(2);
	dbview->slotAddServer();
}

void KPHPDev::slotModules(){
	   tabr->setCurrentTab(1);
	   tabl->setCurrentTab(2);
	dbview->slotModules();
}

void KPHPDev::slotClear(){
	   tabr->setCurrentTab(1);
	   tabl->setCurrentTab(2);
	dbview->slotClear();
}

void KPHPDev::slotFitAll(){
	   tabr->setCurrentTab(1);
	   tabl->setCurrentTab(2);
	dbview->slotFitAll();
}

void KPHPDev::slotViewNew(){
	   tabr->setCurrentTab(1);
	   tabl->setCurrentTab(2);
	dbview->slotViewNew();
}

void KPHPDev::slotViewRemove(){
	   tabr->setCurrentTab(1);
	   tabl->setCurrentTab(2);
	dbview->slotViewRemove();
}

void KPHPDev::slotViewWindowize(){
	   tabr->setCurrentTab(1);
	   tabl->setCurrentTab(2);
	dbview->slotViewWindowize();
}

void KPHPDev::slotViewHtmlExport(){
	   tabr->setCurrentTab(1);
	   tabl->setCurrentTab(2);
	dbview->slotViewHtmlExport();
}

void KPHPDev::slotPrint(){
	   tabr->setCurrentTab(1);
	   tabl->setCurrentTab(2);
	dbview->slotPrint();
}

void KPHPDev::slotSViewWindowize()
	{
//	if(!stab->windowizeCurrentView())
//		QMessageBox::warning(0, i18n("Windowize view"), i18n("Cannot windowize this view."));	
	}

	
void KPHPDev::slotTabLeftChanged(int t){
//	disconnect(tabl,SIGNAL(tabSelected(int)),this,SLOT(slotTabLeftChanged(int)));
	disconnect(tabr,SIGNAL(tabSelected(int)),this,SLOT(slotTabRightChanged(int)));
	if(t==2){
	   tabr->setCurrentTab(1);
	} else {
	   tabr->setCurrentTab(0);
	}
//	connect(tabl,SIGNAL(tabSelected(int)),this,SLOT(slotTabLeftChanged(int)));
	connect(tabr,SIGNAL(tabSelected(int)),this,SLOT(slotTabRightChanged(int)));
}

void KPHPDev::slotTabRightChanged(int t){
	disconnect(tabl,SIGNAL(tabSelected(int)),this,SLOT(slotTabLeftChanged(int)));
//	disconnect(tabr,SIGNAL(tabSelected(int)),this,SLOT(slotTabRightChanged(int)));
	if(t==1 || t==2){
	   tabl->setCurrentTab(2);
	} else {
	   tabl->setCurrentTab(1);
	}
	connect(tabl,SIGNAL(tabSelected(int)),this,SLOT(slotTabLeftChanged(int)));
//	connect(tabr,SIGNAL(tabSelected(int)),this,SLOT(slotTabRightChanged(int)));
}

void KPHPDev::slotExecute(){
	   tabl->setCurrentTab(2);
	   tabr->setCurrentTab(2);
	qa->slotExecute();
}	

void KPHPDev::slotClearRez(){
	   tabl->setCurrentTab(2);
	   tabr->setCurrentTab(2);
	qa->slotClear();
}	

/**  */
void KPHPDev::slotStatusBarPosition(int type,int line, int col){
//  statusBar()->clear();
    QString text="", val;
    if(type && type!=-1)
    		text="INS ";
    else if(type==0)	
    		text="OVR ";
    text+="Line: ";
    val="";
    val.sprintf("%d",line);
    text+=val;
    text+=" Col: ";
    val="";
    val.sprintf("%d",col);
    text+=val;
  statusBar()->changeItem(text, ID_STATUS_POS );
}


