/***************************************************************************
                          kphpdev.h  -  description
                             -------------------
    begin                : Fri Nov 26 21:19:03 EET 1999
    copyright            : (C) 1999 by Tiberiu Craciun
    email                : tiberiu@akela.ro
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef KPHPDEV_H
#define KPHPDEV_H


#include <kapp.h>
#include <qwidget.h>
#include <knewpanner.h>
// include files for KDE
#include <ktmainwindow.h>
#include <qlistview.h>
#include "cedit.h"
#include "cfiles.h"
#include "ctabctl.h"
#include "database/dbwidget.h"
#include "database/queryanalizer.h"
#include "database/servertree.h"

class CRealFileView;
class CTabCtl;
class HlManager;
class KWriteDoc;
class KWrite;
class CServerConnect;
class STabCtl;

class KPHPDev : public KTMainWindow {
  Q_OBJECT 
public: 
  /** construtor */
  KPHPDev(QWidget*parent=0,const char* name=0); 
  /** destructor */
  ~KPHPDev();

protected:
	CRealFileView *rfv;
	CFiles *opened;
	QListView *data;
	CTabCtl *tabl;
	CTabCtl *tabr;
	KNewPanner *view;
	ServerTree *dbtree;
	DBWidget *dbview;
	QueryAnalizer *qa;
//HlManager *hl;
//KWriteDoc *kwd;
//KWrite *kw;
  STabCtl *stab;

private:
	void initMenuBar();
	void initStatusBar();
	void initToolBar();
private:
  QPopupMenu *file_menu;
  /** the recent file menu containing the last five opened files */
  QPopupMenu *recent_files_menu;
  /** contains the recently used filenames */
  QStrList recent_files;
  /** edit_menu contains all items of the menubar entry "Edit" */
  QPopupMenu *edit_menu;
  /** view_menu contains all items of the menubar entry "View" */
  QPopupMenu *view_menu;
  QPopupMenu *options_menu;
  /** help_menu contains all items of the menubar entry "Help" */
  QPopupMenu *help_menu;
public:	
	CServerConnect *dsc;
	CEdit *files;

public slots:
  void statusCallback(int id_);
  void slotStatusHelpMsg(const char *text);
	void commandCallback(int id_);
  /** open a new application window by creating a new instance of Test2App */
  void slotFileNewWindow();
  /** clears the document in the actual view to reuse it as the new document */
  void slotFileNew();
  /** open a file and load it into the document*/
  void slotFileOpen(QString file);
	/** opens a file from the recent files menu */
	void slotFileOpenRecent(int id_);
  /** save a document */
  void slotFileSave();
  void slotFileCloseAll();
  /** save a document by a new filename*/
  void slotFileSaveAs(QString file);
  /** asks for saving if the file is modified, then closes the actual file and window*/
  void slotFileClose();
  void slotFileCloseAs(QString file);
  /** print the actual file */
  void slotFilePrint();
  /** closes all open windows by calling close() on each memberList item until the list is empty, then quits the application.
  	* If queryClose() returns false because the user canceled the saveModified() dialog, the closing breaks.
  	*/
  void slotFileQuit();
  /** put the marked text/object into the clipboard and remove
    *	it from the document
    */
  void slotEditCut();
  /** put the marked text/object into the clipboard
  	*/
  void slotEditCopy();
  /** paste the clipboard into the document
  	*/
  void slotEditPaste();
  /** toggles the toolbar
  	*/
  void slotViewToolBar();
  /** toggles the statusbar
  	*/
  void slotViewStatusBar();
  /** changes the statusbar contents for the standard label permanently, used to indicate current actions.
  	* @param text the text that is displayed in the statusbar
  	*/
  void slotStatusMsg(const char *text);
  void slotExecute();
  void slotClearRez();
protected slots: // Protected slots
  /**  */
  void slotAddServer();
  void slotModules();
  void slotClear();
  void slotFitAll();
  void slotViewNew();
  void slotViewRemove();
  void slotViewWindowize();
  void slotViewHtmlExport();
  void slotPrint();
  void slotSViewWindowize();
  void slotTabLeftChanged(int t);
  void slotTabRightChanged(int t);
public slots:
  void slotTabLeftShow(int t){tabl->setCurrentTab(t);}
  /**  */
  void slotStatusBarPosition(int type,int line, int col);
};
#endif





