/***************************************************************************
                         STabCtl part of KDEStudio
                             -------------------
    copyright            : (C) 1999 by Judin Maximus
    email                : novaprint@mtu-net.ru
 ***************************************************************************/

#ifndef STABCTL_H
#define STABCTL_H

#include <qwidget.h>
#include <qlist.h>

class STabBar;


struct TabCtlData
{
  TabCtlData( QWidget* _widget, int _id )
  {
    widget = _widget;
    id = _id;
    enabled = true;
  }
  ~TabCtlData(){;}

  QWidget* widget;
  int      id;
  bool     enabled;
};

class STabCtl : public QWidget
{ Q_OBJECT
public:
  STabCtl( QWidget *parent = 0, const char *name = 0 );
  ~STabCtl();

  int insertPage( QWidget *, const char* label, int id = -1 );

  void setPixmap( int id, const QPixmap &pix ){ setPixmap( page(id), pix ); }
  void setPixmap( QWidget* , const QPixmap &pix );

  QWidget* page( int );
  int id( QWidget* );

  void removePage( QWidget* );
  void removePage( int id ){ removePage( page(id) ); }

  QWidget* visiblePage();
  int visiblePageId(){ return id( visiblePage() ); }

  void setVisiblePage( QWidget* );

  bool isPageEnabled( int id ){ return isPageEnabled( page(id) ); }
  bool isPageEnabled( QWidget* );

  void setPageEnabled( int id, bool enabled  ){ setPageEnabled( page(id), enabled ); }
  void setPageEnabled( QWidget*, bool );

  void setTabFont( const QFont &font );

  void showTabIcon( bool );

  int  pageCount(){ return mainData->count(); }
  QWidget* getFirstPage();
  QWidget* getNextPage( QWidget* );
  QWidget* getPrevPage( QWidget* );

  virtual void show();

public slots:
  void setVisiblePage(int id){ setVisiblePage( page(id) ); }

protected:
  void paintEvent(QPaintEvent *);
  void resizeEvent(QResizeEvent *);

signals:
  void aboutToShow( QWidget* );
  void pageSelected( QWidget* );
  void tabShowPopup( int, QPoint );

protected slots:
  void rightButtonPress( int, QPoint );

private:
  TabCtlData* findData( QWidget* );
  TabCtlData* findData( int id );
  void showPage( QWidget* );
  QRect getChildRect() const;

  QList<TabCtlData> *mainData;
  QWidget* currentPage;
  STabBar* tabs;
};

#endif


























